commit 09f0f85b86e7488cf26642dd17150f76bed5300c (HEAD -> master)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Dec 18 19:56:49 2017 +0100

    Release 1.8.23

 ChangeLog    | 8 ++++++++
 configure.ac | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit 1dde8427236fa988e9f488baa46d7316691a5555 (origin/master, origin/HEAD)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Nov 14 15:09:25 2017 +0100

    spy: add support SCardStatus() with NULL pcbAtrLen
    
    If an application calls SCardStatus() with pcbAtrLen = NULL then the trace
    interpretation was wrong.
    
    The problematic trace was:
    7F9414EF6700@>|1510667088|620972|SCardStatus
    7F9414EF6700@0x7B0DDEA3
    7F9414EF6700@NULL
    7F9414EF6700@NULL
    7F9414EF6700@NULL
    7F9414EF6700@""
    7F9414EF6700@NULL
    7F9414EF6700@NULL
    7F9414EF6700@NULL
    7F9414EF6700@<|1510667088|621107|SCardStatus|Command successful.|0x00000000
    
    SCardStatus
     i hCard: 0x7B0DDEA3
     i pcchReaderLen NULL
     i pcbAtrLen NULL
     o cchReaderLen NULL
     o mszReaderName ""
     o dwState NULL
     o dwProtocol NULL
     o bAtrLen NULL
     o bAtr
     => Command successful. (SCARD_S_SUCCESS [0x00000000])  [0.000135]
    
    In the trace above the value bAtr is not known (bAtrLen has no value) so
    nothing is displayed.
    
    A more classic trace is:
    7FF91179D700@>|1510668989|105007|SCardStatus
    7FF91179D700@0x2E753ED9
    7FF91179D700@0x00000000
    7FF91179D700@0x00000000
    7FF91179D700@0x0000001D
    7FF91179D700@NULL
    7FF91179D700@0x00050034
    7FF91179D700@0x00000001
    7FF91179D700@0x00000014
    7FF91179D700@NULL
    7FF91179D700@<|1510668989|105301|SCardStatus|Command successful.|0x00000000
    7FF91179D700@>|1510668989|105306|SCardStatus
    7FF91179D700@0x2E753ED9
    7FF91179D700@0x0000001D
    7FF91179D700@0x00000021
    7FF91179D700@0x0000001D
    7FF91179D700@Gemalto PC Twin Reader 00 00
    7FF91179D700@0x00050034
    7FF91179D700@0x00000001
    7FF91179D700@0x00000014
    7FF91179D700@3B 7F 96 00 00 80 31 80 65 B0 85 03 00 EF 12 0F FE 82 90 00
    7FF91179D700@<|1510668989|105365|SCardStatus|Command successful.|0x00000000
    
    giving:
    SCardStatus
     i hCard: 0x2E753ED9
     i pcchReaderLen 0x00000000 (0)
     i pcbAtrLen 0x00000000 (0)
     o cchReaderLen 0x0000001D (29)
     o mszReaderName NULL
     o dwState 0x00050034 (327732)
     o dwProtocol 0x00000001 (1)
     o bAtrLen 0x00000014 (20)
     o bAtr NULL
     => Command successful. (SCARD_S_SUCCESS [0x00000000])  [0.000294]
    SCardStatus
     i hCard: 0x2E753ED9
     i pcchReaderLen 0x0000001D (29)
     i pcbAtrLen 0x00000021 (33)
     o cchReaderLen 0x0000001D (29)
     o mszReaderName Gemalto PC Twin Reader 00 00
     o dwState 0x00050034 (327732)
     o dwProtocol 0x00000001 (1)
     o bAtrLen 0x00000014 (20)
     o bAtr 3B 7F 96 00 00 80 31 80 65 B0 85 03 00 EF 12 0F FE 82 90 00
     => Command successful. (SCARD_S_SUCCESS [0x00000000])  [0.000059]

 src/spy/pcsc-spy | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 661c56584f3806ca47944a2c989eb79b9b89b74d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Nov 14 13:32:17 2017 +0100

    spy: add support of Ubuntu
    
    On Ubuntu libpcsclite.so.1 is in /lib/... but libpcscspy.so is in
    /usr/lib/...
    The 2 libraries are not in the same directory.

 src/spy/install_spy.sh | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit c19857227058b38a37f19e4e6bf83bb4a93ecb7f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 26 15:13:54 2017 +0200

    SCardGetStatusChange(): fix comment
    
    After cancellable is set to FALSE then SCardCancel() will just return
    immediatly with success.

 src/winscard_clnt.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 7424c7a32006c332383e9d17827b700dc369913f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 19 22:18:16 2017 +0200

    .gitignore: remove no more present files

 .gitignore | 2 --
 1 file changed, 2 deletions(-)

commit 180e5c678365b7d1b078f49b0ae881d3ce6f10a5
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 19 22:09:37 2017 +0200

    .gitignore: sort lines

 .gitignore | 56 ++++++++++++++++++++++++++++----------------------------
 1 file changed, 28 insertions(+), 28 deletions(-)

commit 0e5ef3e2cb399c472ca91fb1270ac3e294bbd9d6
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 19 22:07:31 2017 +0200

    .gitignore: ignore generated files

 .gitignore | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 1324532eee4342aa17ad16617c8d6ae03b3e4b96
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 21 13:13:08 2017 +0200

    RFAddReader(): simplify code
    
    The cases rv != IFD_SUCCESS and dwGetSize != 1 are already managed by
    the previous if(). So no need to test again these values.

 src/readerfactory.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5905bbe11414c131a32a7d84829eaa5d060bd55d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 21 13:10:52 2017 +0200

    Fix compiler warning (gcc 7)
    
    Use an intermediate variable nbSlots.
    
    readerfactory.c: In function ‘RFAddReader’:
    readerfactory.c:457:51: warning: ‘%02X’ directive output may be truncated writing between 2 and 8 bytes into a region of size 3 [-Wformat-truncation=]
       snprintf(tmpReader + strlen(tmpReader) - 2, 3, "%02X", j);
                                                       ^~~~
    readerfactory.c:457:50: note: directive argument in the range [1, 2147483646]
       snprintf(tmpReader + strlen(tmpReader) - 2, 3, "%02X", j);
                                                      ^~~~~~
    In file included from /usr/include/stdio.h:938:0,
                     from readerfactory.c:43:
    /usr/include/x86_64-linux-gnu/bits/stdio2.h:64:10: note: ‘__builtin___snprintf_chk’ output between 3 and 9 bytes into a destination of size 3
       return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,
              ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            __bos (__s), __fmt, __va_arg_pack ());
            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 src/readerfactory.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit f1fa9106513ac6990719c677f053bdee558c661d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Aug 1 10:11:29 2017 +0200

    configure.ac: fix typo in help message

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8946edadaca353d65112664a5fcd7bbe1be54ed5
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jul 12 17:59:48 2017 +0200

    simclist: fix a potential memory leak
    
    Changes in a801c6e613fde89c09c755a20003ab82fd6a5c47 added tests and
    returns in case of errors.
    
    If something fails in list_insert_at() we must free the memory allocated
    for the new element (that was not inserted).

 src/simclist.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 30e10951f81b9480e788965f89d0d4d0aee909c0 (zotac/master, github/master)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jul 13 17:52:13 2017 +0200

    Use libsystemd instead sd-daemon.{c,h}
    
    Remove files src/sd-daemon.{c,h} and use libsystemd to get
    sd_listen_fds() and sd_is_socket() implementations.
    So we do not have to maintain systemd specific code.
    
    Use --disable-systemd if you do not have libsystemd available. In that
    case I think you do not use systemd either.

 configure.ac           |  12 ++
 src/Makefile.am        |  10 +-
 src/pcscdaemon.c       |   8 +-
 src/sd-daemon.c        | 526 -------------------------------------------------
 src/sd-daemon.h        | 277 --------------------------
 src/winscard_msg_srv.c |   6 +-
 6 files changed, 26 insertions(+), 813 deletions(-)

commit 696023944649e0c52802e20994fb78d6b24d4efd (tag: pcsc-1.8.22)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Jun 17 08:56:54 2017 +0200

    Release 1.8.22
    
    Signed-off-by: Ludovic Rousseau <ludovic.rousseau@free.fr>

 ChangeLog    | 6 ++++++
 configure.ac | 2 +-
 2 files changed, 7 insertions(+), 1 deletion(-)

commit 7307cc4a80f887ef59487d7b8edf104fb56f13ca
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 15 14:50:28 2017 +0200

    UnitaryTests/SCardCancel.c: test for SCardCancel
    
    Check that the fix in 81d52b98d84be900c6a6532d10d1fe88eac092cf works as
    expected.

 UnitaryTests/Makefile      |  1 +
 UnitaryTests/SCardCancel.c | 88 ++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 89 insertions(+)

commit 7a3738d2f8e48c669b0e3f485cb9dcabeffc941a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 15 14:45:48 2017 +0200

    fix SCardCancel() that was broken in version 1.8.21
    
    Changes in 9a21c82330fc4b73ac00faf2c5cf948da5f8ab07 broke
    SCardCancel().
    The problem was that SCardCancel() was blocked until
    SCardGetStatusChange() had finished. This is stupid because
    SCardCancel() is supposed to cancel SCardGetStatusChange().
    
    Thanks to Ran Benita for the bug report
    "[Pcsclite-muscle] A recent change causes SCardCancel() to block?"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/2017-June/000921.html

 src/winscard_clnt.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 88a53f3ed21aa645e7c65661162f832a053fb9de
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jun 9 09:58:52 2017 +0200

    RFAddReader: more correctly detect duplicate readers
    
    To detect a duplicate reader, checking the reader name and port is,
    sometimes, not enough.
    
    The problem was when two readers are removed and re-inserted immediately.
    One of the 2 readers may not yet be completely removed (from pcscd point
    of view) when it is asked to insert it again.
    
    Fixes #20
    "Reader not detected when disconnecting / connecting usb hub"
    https://github.com/LudovicRousseau/PCSC/issues/20

 src/readerfactory.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 251771ad2c6278f460a995fb07ee02281930f987
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jun 6 17:53:52 2017 +0200

    DebugLogSetLevel: PCSC_LOG_INFO is "info"
    
    Level name "notice" was used for PCSC_LOG_INFO. We now use the label
    "info".

 src/debuglog.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit fa313f5442e78d312e18e025906a0ab43aa27a5e
Author: Maximilian Stein <Maximilian.Stein@secunet.com>
Date:   Wed May 3 15:29:45 2017 +0200

    Enable info level logging

 src/pcscdaemon.c | 11 ++++++++---
 1 file changed, 8 insertions(+), 3 deletions(-)

commit f47cccffcb534a7bd3528790d55d7ce5a71d70de (tag: pcsc-1.8.21)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat May 20 17:11:50 2017 +0200

    Release 1.8.21
    
    Signed-off-by: Ludovic Rousseau <ludovic.rousseau@free.fr>

 ChangeLog    | 18 ++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 19 insertions(+), 1 deletion(-)

commit a801c6e613fde89c09c755a20003ab82fd6a5c47
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Wed Apr 12 16:08:53 2017 +0200

    simclist: handle faults during memory allocation
    
    fixes several situations that cause segmentation faults

 src/simclist.c | 111 +++++++++++++++++++++++++++++++++++++++++----------------
 1 file changed, 81 insertions(+), 30 deletions(-)

commit 8edd183ec82c826b228fd599d5529a0f111cd97b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 18 13:14:58 2017 +0200

    Doxygen: add a sample code of multi-string use
    
    Add a sample code of how to parse the multi-string returned by
    SCardListReaders().

 src/winscard_clnt.c | 13 +++++++++++--
 1 file changed, 11 insertions(+), 2 deletions(-)

commit fd1e32d0b524325a88e7e5b25a8cc2bd897ae668
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat May 13 21:38:40 2017 +0200

    SCardDisconnect(): refactoring code
    
    Handle the error cases for SCARD_UNPOWER_CARD and SCARD_RESET_CARD in
    the same code block. This avoids code duplication.

 src/winscard.c | 38 ++++++++++++++------------------------
 1 file changed, 14 insertions(+), 24 deletions(-)

commit 8edae1590448eb0519924434f7ba897ceef8d890
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat May 13 21:24:40 2017 +0200

    SCardDisconnect(): fix status update for SCARD_UNPOWER_CARD
    
    Store the value returned by IFDPowerICC(, IFD_POWER_DOWN, ).
    This value is then used later to decide if the powering down was a
    success or not and set the card status accordingly.
    
    The problem was detected by pcsc_scan stress code. If a SCardTransmit()
    fails because the card is removed then SCardDisconnect() is called to
    unpower the card.
    Because the card is removed the powering down fails but the card status
    was not correctly updated.

 src/winscard.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6cba8a28c66b836244d920ebe0b9010b2302fc93
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat May 13 21:20:05 2017 +0200

    Revert "SCardDisconnect(): fix ATR update for SCARD_UNPOWER_CARD"
    
    This reverts commit 70468bfaa08eae5715312de43aecb873a2df115f.

 src/winscard.c | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 70468bfaa08eae5715312de43aecb873a2df115f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri May 12 15:16:34 2017 +0200

    SCardDisconnect(): fix ATR update for SCARD_UNPOWER_CARD
    
    When the card is disconnected with SCARD_RESET_CARD or
    SCARD_UNPOWER_CARD then disable the current ATR early in the code and in
    all cases.
    
    The problem was that the ATR was disabled only in the case
    SCARD_RESET_CARD and only in case of failure.
    So if SCARD_UNPOWER_CARD was used the ATR was still considered as valid,
    even if the card was no more powered.

 src/winscard.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 582408c38397b7f36a30ec05cdbda06008d834ff
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 15:22:00 2017 +0200

    Remove dead code
    
    If rv indicates an error then the program has already exited using
    test_rv(rv, hContext, PANIC);

 src/testpcsc.c | 6 ------
 1 file changed, 6 deletions(-)

commit 091d501225eb1eef5535f4f7e0e07a0ae8cf909e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 15:16:19 2017 +0200

    DebugLogSetCategory() returns void now
    
    The value returned by DebugLogSetCategory() was ignored.
    Now the DebugLogSetCategory() function returns void.

 src/PCSC/debuglog.h | 2 +-
 src/debuglog.c      | 6 ++----
 src/pcscdaemon.c    | 2 +-
 3 files changed, 4 insertions(+), 6 deletions(-)

commit 6afb6cbfa029a3b52ef0b0e9b7f76b9c9d88dd18
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 15:07:28 2017 +0200

    Remove useless PMRegisterForPowerEvents()
    
    Remove the complete powermgt_generic.[c,h] files.
    
    powermgt_macosx.c has been removed in April 2009
    in c199045d62e2255ec07d49becff4f94d67943676.
    
    Since then no power management was used in pcsc-lite.

 src/Makefile.am        |  2 --
 src/pcscdaemon.c       |  6 ------
 src/powermgt_generic.c | 54 --------------------------------------------------
 src/powermgt_generic.h | 44 ----------------------------------------
 4 files changed, 106 deletions(-)

commit f65dcd88221e07a9d18b4d8856bf266b1bb2459e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 15:00:31 2017 +0200

    Remove useless RFDestroyReaderHandle()
    
    The function RFDestroyReaderHandle() does nothing. So just remove it.

 src/readerfactory.c | 6 ------
 src/readerfactory.h | 1 -
 src/winscard.c      | 3 ---
 3 files changed, 10 deletions(-)

commit bf89546ea67334a708cc9c904d53a4068733474a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:57:49 2017 +0200

    SCardCleanContext() returns void now
    
    The value returned by SCardCleanContext() was ignored.
    Now the SCardCleanContext() function returns void.

 src/winscard_clnt.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit a7e8bd92ebea20c7b284aa7b9e600cd1ceb958c0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:56:48 2017 +0200

    SCardRemoveContext() returns void now
    
    The value returned by SCardRemoveContext() was ignored.
    Now the SCardRemoveContext() function returns void.

 src/winscard_clnt.c | 12 +++++-------
 1 file changed, 5 insertions(+), 7 deletions(-)

commit fa41a2adf64ad0ca8f9daa8b1db3f46c172cc5bc
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:54:34 2017 +0200

    ClientCloseSession() returns void now
    
    The value returned by ClientCloseSession() was ignored.
    Now the ClientCloseSession() function returns void.

 src/winscard_clnt.c | 2 +-
 src/winscard_msg.c  | 4 ++--
 src/winscard_msg.h  | 2 +-
 3 files changed, 4 insertions(+), 4 deletions(-)

commit 784f217350d8657c69e62aea2a1a483b288df09e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:52:43 2017 +0200

    RFSetReaderEventState() returns void now
    
    The value returned by RFSetReaderEventState() was ignored.
    Now the RFSetReaderEventState() function returns void.

 src/readerfactory.c | 4 ++--
 src/readerfactory.h | 2 +-
 src/winscard.c      | 6 +++---
 3 files changed, 6 insertions(+), 6 deletions(-)

commit d3b1b7217325f67db27a6d5519294c5b65003266
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:50:05 2017 +0200

    SCardRemoveHandle() returns void now
    
    The value returned by SCardRemoveHandle() was ignored.
    Now the SCardRemoveHandle() function returns void.

 src/winscard_clnt.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit a1a7ca2803f0f87dc2371eaf2572abc7795fd98a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:47:44 2017 +0200

    SCardLockThread() and SCardUnlockThread() returns void now
    
    The value returned by SCardLockThread() and SCardUnlockThread() was
    ignored.
    Now the SCardLockThread() and SCardUnlockThread() functions returns
    void.

 src/winscard_clnt.c | 28 ++++++++++++++--------------
 1 file changed, 14 insertions(+), 14 deletions(-)

commit 440f15e433123b7e99d37ba772a16662e4b838c0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:45:26 2017 +0200

    MSGCleanupClient() returns void now
    
    The value returned by MSGCleanupClient() was ignored.
    Now the MSGCleanupClient() function returns void.

 src/winscard_svc.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit c5881b330443d5ed64307b580310d93a13e66aab
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:38:12 2017 +0200

    EHSignalEventToClients() returns void now
    
    The value returned by EHSignalEventToClients() was ignored.
    Now the EHSignalEventToClients() function returns void.

 src/eventhandler.c  | 17 +++++++----------
 src/eventhandler.h  |  2 +-
 src/readerfactory.c |  2 +-
 3 files changed, 9 insertions(+), 12 deletions(-)

commit 2e5a0c53d92328099bf39441121754e41116da4c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:34:08 2017 +0200

    Minor code reformat

 src/pcscdaemon.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 2d64467399d286e79328d0f5caba7f67692dd0da
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 14:31:18 2017 +0200

    EHDestroyEventHandler() returns void now
    
    The value returned by EHDestroyEventHandler() was ignored.
    Now the EHDestroyEventHandler() function returns void.

 src/eventhandler.c  | 6 +++---
 src/eventhandler.h  | 2 +-
 src/readerfactory.c | 2 +-
 3 files changed, 5 insertions(+), 5 deletions(-)

commit b024b2ac275eaefecb2553710242d29f607a376f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 11:01:49 2017 +0200

    IFDPowerICC(): Fix internal use of IFDStatusICC()
    
    IFDStatusICC() is not a IFDHandler function but a ifdwrapper function.
    It returns SCARD_* values and not IFD_* values.
    
    By luck, the code was not broken because we have
    IFD_SUCCESS = SCARD_S_SUCCESS = 0

 src/ifdwrapper.c | 9 ++-------
 1 file changed, 2 insertions(+), 7 deletions(-)

commit cbe677fc8fe94663fa70c5179385b17bdb7debec
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 11 10:30:03 2017 +0200

    Fix SCardGetStatusChange() when a reader is removed
    
    Because of a race condition, a smart card reader removal may, in some
    conditions, not be detected on the client side.
    
    The problem is that when a reader is removed the clients are notified
    (using EHSignalEventToClients() function) two times:
    - the first time in EHStatusHandlerThread() from eventhandler.c just
      before the event thread exists,
    - the second time in removeReader() from readerfactory.c after the
      reader has been removed
    
    The problem is that the first time the clients are notified the reader
    state has not yet changed. The reader is still visible by the clients.
    If a client is slow to register to new events it may miss the second
    notification and then wait "forever" in SCardGetStatusChange()
    ("forever" is defined as 60 seconds here as it is the event loop timeout).
    
    The solution is to removed the first (in fact useless) notification.
    
    Thanks to Maximilian Stein for the bug report and patch
    "[Pcsclite-muscle] Race condition with SCardGetStatusChange() when USB
    Reader is removed"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170508/000855.html

 src/eventhandler.c | 1 -
 1 file changed, 1 deletion(-)

commit 36bf013a76ba953992ef1413878ac4866852fcc8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 4 10:00:02 2017 +0200

    Doxygen: fix typo

 src/winscard_clnt.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 1928b55be239fdd853c67bcc355c59d908978d71
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 4 09:51:16 2017 +0200

    removeReader(): reformat code
    
    The complete function code was inside a { } block.
    I removed the { } block and one level of indentation.

 src/readerfactory.c | 110 ++++++++++++++++++++++++++--------------------------
 1 file changed, 54 insertions(+), 56 deletions(-)

commit 789dae8a8acf8d1693597159d7d590a96bdd6424
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 4 09:47:16 2017 +0200

    Do not check RFUnInitializeReader() return value
    
    RFUnInitializeReader() always returns SCARD_S_SUCCESS so it is useless
    to check the returned value.
    
    RFUnInitializeReader() now returns void instead.

 src/readerfactory.c | 10 +++-------
 src/readerfactory.h |  2 +-
 2 files changed, 4 insertions(+), 8 deletions(-)

commit 59489545659447d297e51f3c3c281f377d350851
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Apr 20 10:33:22 2017 +0200

    pcsc-spy: port to Python3
    
    On Python3 the Queue module is called queue.
    
    The program now works with Python 2.7 and Python 3.4.
    
    Thanks to Johannes Meixner for the bug report
    "Make pcsc-spy python3-ready"
    https://github.com/LudovicRousseau/PCSC/issues/19

 src/spy/pcsc-spy | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit dc30c32973f91b61916db1fd17528b99cb7190ce
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Apr 20 10:29:43 2017 +0200

    pcsc-spy: use print as a function
    
    Migrate from print "foobar" to print("foobar") to make the code more
    Python3.

 src/spy/pcsc-spy | 120 +++++++++++++++++++++++++++++--------------------------
 1 file changed, 63 insertions(+), 57 deletions(-)

commit aee7bd1666f39088c968107c19d945da59287bfd
Author: Ludovic Rousseau <ludovic.rousseau+github@gmail.com>
Date:   Thu Apr 6 20:18:33 2017 +0200

    README.md: add Code Climate badge

 README.md | 1 +
 1 file changed, 1 insertion(+)

commit 1ac4b7da5f17883968950a6f88b19320ca21f846
Author: Ludovic Rousseau <ludovic.rousseau+github@gmail.com>
Date:   Thu Apr 6 20:17:33 2017 +0200

    Create README.md
    
    New file so that github displays a nice project presentation.

 README.md | 8 ++++++++
 1 file changed, 8 insertions(+)

commit a58854e085be7054213a128bdc227916bd84ccc6
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 29 10:11:10 2017 +0200

    Doxygen: Improve documentation about SCardCancel()
    
    SCardCancel() cancels only one specific SCardGetStatusChange() call, not
    *all* the currently running SCardGetStatusChange() calls.

 src/winscard_clnt.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 9311af0419da38e2c10842456694d0c15b78150e
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Wed Mar 29 10:39:58 2017 +0300

    Doxygen: Improve documentation about SCardCancel()
    
    SCardCancel() MUST be called with the same SCARDCONTEXT as
    SCardGetStatusChange().

 src/winscard_clnt.c | 11 ++++++++---
 1 file changed, 8 insertions(+), 3 deletions(-)

commit 62ecbe87bfbecc0706f110738e0f609d848d0bd3
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 1 16:01:44 2017 +0100

    --enable-embedded: fix compiler warning
    
    winscard_svc.c: In function ‘ContextsDeinitialize’:
    winscard_svc.c:150:6: warning: variable ‘listSize’ set but not used [-Wunused-but-set-variable]
      int listSize;
          ^~~~~~~~

 src/winscard_svc.c | 3 +++
 1 file changed, 3 insertions(+)

commit ad7f77fa498f8901983ed0406cea1bf6602a5bd7
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 1 16:00:13 2017 +0100

    --enable-embedded: fix compiler warning
    
    winscard.c: In function ‘SCardReleaseContext’:
    winscard.c:220:39: warning: unused parameter ‘hContext’ [-Wunused-parameter]
     LONG SCardReleaseContext(SCARDCONTEXT hContext)
                                           ^~~~~~~~

 src/winscard.c | 3 +++
 1 file changed, 3 insertions(+)

commit 8b41f649b65079ec232bf584ed0ca5cc066fcb94
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 1 15:59:03 2017 +0100

    --enable-embedded: fix compiler warning
    
    hotplug_libudev.c: In function ‘get_driver’:
    hotplug_libudev.c:269:14: warning: unused parameter ‘devpath’ [-Wunused-parameter]
      const char *devpath, struct _driverTracker **classdriver)
                  ^~~~~~~

 src/hotplug_libudev.c | 3 +++
 1 file changed, 3 insertions(+)

commit d64a505d24cd11bc3d8e879fff4ba3675be9bcfc
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 1 15:57:12 2017 +0100

    --enable-embedded: fix compiler warning
    
    eventhandler.c: In function ‘EHStatusHandlerThread’:
    eventhandler.c:248:14: warning: variable ‘readerName’ set but not used [-Wunused-but-set-variable]
      const char *readerName;
                  ^~~~~~~~~~

 src/eventhandler.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 37cee3b3c45520c06e9c39d034771e6cba58a1e2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 1 15:55:30 2017 +0100

    --enable-embedded: fix compiler warning
    
    dyn_unix.c: In function ‘DYN_GetAddress’:
    dyn_unix.c:85:30: warning: unused parameter ‘mayfail’ [-Wunused-parameter]
      const char *pcFunction, int mayfail)
                                  ^~~~~~~

 src/dyn_unix.c | 3 +++
 1 file changed, 3 insertions(+)

commit 24cf3ad628028376cc9645bacfaec8a58cfc15a5
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 1 15:52:49 2017 +0100

    --enable-embedded: fix compiler warning
    
    configfile.l: In function ‘tok_error’:
    configfile.l:259:22: warning: unused parameter ‘token_error’ [-Wunused-parameter]
     {
                          ^

 src/configfile.l | 3 +++
 1 file changed, 3 insertions(+)

commit aa4907aaecc73680a4ac557cd0a9a00a563302d9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 1 15:50:18 2017 +0100

    --enable-embedded: fix compiler warning
    
    winscard_msg.c: In function ‘MessageReceiveTimeout’:
    winscard_msg.c:193:46: warning: unused parameter ‘command’ [-Wunused-parameter]
     INTERNAL LONG MessageReceiveTimeout(uint32_t command, void *buffer_void,
                                                  ^~~~~~~

 src/winscard_msg.c | 3 +++
 1 file changed, 3 insertions(+)

commit 35d660edb22ccae8a2e1d3e86316d15c7d33205b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 28 16:34:57 2017 +0100

    Rename BufferOverflow2.c -> BufferOverflow_SCardTransmit.c

 UnitaryTests/{BufferOverflow2.c => BufferOverflow_SCardTransmit.c} | 0
 UnitaryTests/Makefile                                              | 2 +-
 2 files changed, 1 insertion(+), 1 deletion(-)

commit 30ece5141a55aa57976b5c50e32159c6de0de108
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 28 16:33:52 2017 +0100

    Rename BufferOverflow.c -> BufferOverflow_SCardGetAttrib.c

 UnitaryTests/{BufferOverflow.c => BufferOverflow_SCardGetAttrib.c} | 0
 UnitaryTests/Makefile                                              | 2 +-
 2 files changed, 1 insertion(+), 1 deletion(-)

commit 4c57679826bf1fbfda995a7869f8a19c572a2784
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 28 16:31:47 2017 +0100

    Add BufferOverflow_SCardControl.c test code
    
    Test for the patch implemented in 09cf6c7de55f1b4ab1d8a3f86c7a56d7a8621538

 UnitaryTests/BufferOverflow_SCardControl.c | 81 ++++++++++++++++++++++++++++++
 UnitaryTests/Makefile                      |  1 +
 2 files changed, 82 insertions(+)

commit 09cf6c7de55f1b4ab1d8a3f86c7a56d7a8621538
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 28 16:24:53 2017 +0100

    SCardControl() may return SCARD_E_INSUFFICIENT_BUFFER
    
    SCardControl() now correctly returns SCARD_E_INSUFFICIENT_BUFFER when
    pbRecvBuffer is not big enough to receive the card response.
    
    The CCID driver does the check and correctly and returned
    CM_IOCTL_GET_FEATURE_REQUEST in such a case but not all IFD Handler may
    be smart enough.
    
    This change is similar to the same change for SCardTransmit() done in
    8eb9ea1b354b050f997d003cf3b0c5b56f29f9f7 (29 mai 2015)
    
    Thanks to Maximilian Stein for the patch
    "[Pcsclite-muscle] SCardControl() should return SCARD_E_INSUFFICIENT_BUFFER similar to SCardTransmit()"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170213/000815.html

 src/winscard_clnt.c | 2 +-
 src/winscard_svc.c  | 8 +++++++-
 2 files changed, 8 insertions(+), 2 deletions(-)

commit 7c232a11e2e5515fd886733b3e382fc91ea0a8ab
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Feb 16 11:56:32 2017 +0100

    Python 3: port FEATURE_CCID_ESC_COMMAND_Gemalto_features.py

 UnitaryTests/FEATURE_CCID_ESC_COMMAND_Gemalto_features.py | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 1c5426260c8e74e4bdfe2bbd27eb4336f49cc7ed
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Feb 16 00:17:42 2017 +0100

    Python 3: fix SCardGetStatusChange()
    
    The SCardGetStatusChange() readerstatelist argument must be a list.
    With Python 3 a dict.values() if of type dict_values instead of list in
    Python 2. So we force a conversion into a list using list().

 UnitaryTests/SCardCancel.py           | 6 ++++--
 UnitaryTests/SCardCancel3.py          | 6 ++++--
 UnitaryTests/SCardGetStatusChange.py  | 6 ++++--
 UnitaryTests/SCardGetStatusChange2.py | 3 ++-
 4 files changed, 14 insertions(+), 7 deletions(-)

commit 5a8bacfed5ea046559efac090824630b219474e2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Feb 16 00:06:54 2017 +0100

    Python 3: use PEP 3110 exception format
    
    Use the "new" syntax "except Exception as message:" supported since
    Python 2.6
    
      File "SCardCancel2.py", line 47
        except Exception, message:
                        ^
    SyntaxError: invalid syntax

 UnitaryTests/SCardCancel2.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 317b673868a0bf6bdc798414bdc5d8e32cfaa663
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Feb 15 23:51:14 2017 +0100

    pep8: fix warning
    
    MCT_ReaderDirect.py:70:5: E265 block comment should start with '# '

 UnitaryTests/MCT_ReaderDirect.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a15f6012bcedb871fad486a68bada20fb08e1ca3
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Feb 15 23:50:05 2017 +0100

    pep8: fix warnings
    
    SCardBlockingBehaviourTest.py:132:1: E265 block comment should start with '# '
    SCardBlockingBehaviourTest.py:214:5: E265 block comment should start with '# '
    SCardBlockingBehaviourTest.py:241:9: E265 block comment should start with '# '

 UnitaryTests/SCardBlockingBehaviourTest.py | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit cc912f8c051f57208756a44780aabea28438d884
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Feb 15 23:48:57 2017 +0100

    pep8: fix warning
    
    ThreadSafe.py:44:9: E265 block comment should start with '# '

 UnitaryTests/ThreadSafe.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 44d400f0072c3a8ab1eb2aa6b225fa82a34d0808
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Feb 15 23:48:03 2017 +0100

    pep8: fix warning
    
    ThreadSafeConnect.py:72:1: E302 expected 2 blank lines, found 1

 UnitaryTests/ThreadSafeConnect.py | 1 +
 1 file changed, 1 insertion(+)

commit 876403e6a48070f26fb7eb1211b7bb2df5e52ed1
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Feb 15 23:45:00 2017 +0100

    UnitaryTests: Python3: use print() function
    
    Use:
    from __future__ import print_function
    to make the same Python code to work with both Python 2 and Python 3.

 .../FEATURE_CCID_ESC_COMMAND_Gemalto_features.py   | 77 +++++++++++-----------
 UnitaryTests/FEATURE_CCID_ESC_COMMAND_Xiring.py    | 11 ++--
 UnitaryTests/FEATURE_GET_TLV_PROPERTIES.py         |  9 +--
 UnitaryTests/MCT_ReaderDirect.py                   | 28 ++++----
 UnitaryTests/SCardBeginTransaction_Disconnect.py   |  5 +-
 .../SCardBeginTransaction_ExclusiceMode.py         |  5 +-
 UnitaryTests/SCardBeginTransaction_Reset.py        | 11 ++--
 UnitaryTests/SCardBeginTransaction_deadlock.py     | 35 +++++-----
 UnitaryTests/SCardBlockingBehaviourTest.py         | 49 +++++++-------
 UnitaryTests/SCardCancel.py                        | 13 ++--
 UnitaryTests/SCardCancel2.py                       |  9 +--
 UnitaryTests/SCardCancel3.py                       | 21 +++---
 UnitaryTests/SCardConnect_DIRECT.py                | 13 ++--
 UnitaryTests/SCardConnect_DIRECT2.py               | 11 ++--
 UnitaryTests/SCardEndTransaction_extra_call.py     | 15 +++--
 UnitaryTests/SCardExclusiveBehaviour.py            | 21 ++++--
 UnitaryTests/SCardGetAttrib.py                     | 11 ++--
 UnitaryTests/SCardGetStatusChange.py               | 15 +++--
 UnitaryTests/SCardGetStatusChange2.py              | 15 +++--
 UnitaryTests/SCardReconnect.py                     |  7 +-
 UnitaryTests/SCardStatus.py                        | 29 ++++----
 UnitaryTests/SCard_fork.py                         | 25 +++----
 UnitaryTests/ThreadSafe.py                         |  7 +-
 UnitaryTests/ThreadSafeConnect.py                  | 15 +++--
 UnitaryTests/control_get_firmware.py               | 13 ++--
 UnitaryTests/control_switch_interface.py           | 15 +++--
 UnitaryTests/getAttrib.py                          | 12 ++--
 UnitaryTests/reset_card.py                         |  9 +--
 UnitaryTests/stress_apdu.py                        | 15 +++--
 UnitaryTests/stress_get_firmware.py                | 11 ++--
 UnitaryTests/transmit_loop.py                      |  7 +-
 31 files changed, 290 insertions(+), 249 deletions(-)

commit 25f9089e5c9c082b3c88f3687bdb27db048cc9a9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jan 27 11:01:41 2017 +0100

    Doxygen: fix SCardGetAndLockContext() documentation

 src/winscard_clnt.c | 19 ++++++++++++++-----
 1 file changed, 14 insertions(+), 5 deletions(-)

commit 8193d6fad84539af03a329e0f6911125f96497d0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jan 27 10:43:35 2017 +0100

    Client side: SCardGetAndLockContext() always locks
    
    SCardGetAndLockContext() has the lock parameter removed and now always
    lock.
    
    From Maksim Ivanov:
       Also it may be advisable to change the SCardGetAndLockContext
       function interface so that it's more difficult to use it in thread-unsafe
       manner: remove the second parameter "int lock" and make the
       locking behavior the default one, and introduce another function
       that does no locks and returns a boolean instead of an
       SCONTEXTMAP* pointer.
    
    Thanks to Maksim Ivanov for the proposal
    "[Pcsclite-muscle] Data races related to SCardCancel"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000789.html

 src/winscard_clnt.c | 19 +++++++++----------
 1 file changed, 9 insertions(+), 10 deletions(-)

commit ccfcd6e75ba9ccb5da02e18e5af909d8ec5f146a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jan 27 10:36:02 2017 +0100

    Client side: add and use SCardGetContextValidity()
    
    SCardGetContextValidity(hContext) returns a boolean and does not take
    any lock.
    It is similar to SCardGetAndLockContext(hContext, FALSE)
    
    Thanks to Maksim Ivanov for the idea
    "[Pcsclite-muscle] Data races related to SCardCancel"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000789.html

 src/winscard_clnt.c | 28 ++++++++++++++++++++++------
 1 file changed, 22 insertions(+), 6 deletions(-)

commit 9a21c82330fc4b73ac00faf2c5cf948da5f8ab07
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jan 27 10:26:11 2017 +0100

    SCardCancel(): fix a possible use after free
    
    From Maksim Ivanov:
    " It seems that there are still some issues with regard to the blocking
    requests cancellation functionality in PC/SC-Lite:
    
    2. Use-after-free possible in SCardCancel.
    
       This is probably a low-severity issue, as the deallocated memory will
       be accessed only for reading an int, which would be then used for
       deciding whether to fail fast or to send a request to the daemon
       (the latter is expected to fail anyway).
    
    For #2, the suggestion is to move the reading of the
       currentContextMap->cancellable flag under the clientMutex lock.
    
       Also it may be advisable to change the SCardGetAndLockContext
       function interface so that it's more difficult to use it in thread-unsafe
       manner: remove the second parameter "int lock" and make the
       locking behavior the default one, and introduce another function
       that does no locks and returns a boolean instead of an
       SCONTEXTMAP* pointer. "
    
    Thanks to Maksim Ivanov for the bug report and solution
    "[Pcsclite-muscle] Data races related to SCardCancel"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000789.html

 src/winscard_clnt.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit b662aa1ae24267150d816a08f757b1c1539411ca
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jan 27 09:39:40 2017 +0100

    ContextThread(): fix a SCARD_CANCEL race bug
    
    From Maksim Ivanov:
    " It seems that there are still some issues with regard to the blocking
    requests cancellation functionality in PC/SC-Lite:
    
    1. Extra SCARD_E_CANCELLED events may be sent by the daemon to the
       client that was previously performing an SCardGetStatusChange call.
    
       One scenario is that two concurrent SCardCancel calls succeeding
       simultaneously, and another scenario is an SCardCancel call
       succeeding simultaneously with an event sending from the status
       handler thread.
    
       As a result, the app<->daemon communication will break.
    
    Suggested solutions:
    
    For #1, suggesting to change the SCARD_CANCEL handler to firstly do
       EHUnregisterClientForEvent, and, only if it returns success, then
       send the SCARD_E_CANCELLED event to the client. "
    
    Now MSGSignalClient() is called only if EHUnregisterClientForEvent()
    succeeds i.e. the client was still blocked in a SCardGetStatusChange().
    
    If SCardGetStatusChange() was already canceled or finished then we do not
    signal the client.
    
    Thanks to Maksim Ivanov for the bug report and solution
    "[Pcsclite-muscle] Data races related to SCardCancel"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000789.html

 src/winscard_svc.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit ed741436fd6ce048b73b0d3e1b343c7aea7691cc
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jan 27 09:34:44 2017 +0100

    ContextThread(): minor code reformat
    
    Set SCARD_E_INVALID_HANDLE as a default return value for SCARD_CANCEL.
    
    This change will be needed later in the next commits.

 src/winscard_svc.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 651cf79f4b80a7c72f097e6a598b6199a753c063
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Jan 22 16:47:13 2017 +0100

    Doxygen: better pcsc_stringify_error() documentation
    
    pcsc_stringify_error() uses Thread-Local Storage (TLS) for the returned
    buffer.
    
    Thanks to Maksim Ivanov
    "[Pcsclite-muscle] pcsc_stringify_error thread safety"
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000788.html

 src/error.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 9726152f2c6767f0fa3103ad307dc28ef7923852
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jan 18 17:16:16 2017 +0100

    Fix compilation error with GCC 4.9
    
    GCC 4.9 does not like when "__thread" is before "static"
    
    error.c: In function 'pcsc_stringify_error':
    error.c:81:2: error: '__thread' before 'static'
      __thread static char strError[75];
      ^
    
    clang 8.0 accept both constructions.

 src/error.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b27f0e54194dcfb4db8179dceede8a649141fea4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jan 18 17:10:51 2017 +0100

    pcsc_stringify_error() now returns a const char *
    
    The pcsc_stringify_error() function returns a C-string stored in a
    static buffer. The buffer should NOT be modified outside of
    pcsc_stringify_error().
    
    Thanks to Nikos Mavrogiannopoulos for the idea
    "[Pcsclite-muscle] pcsc_stringify_error thread safety"
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000785.html

 src/PCSC/pcsclite.h.in | 2 +-
 src/error.c            | 4 ++--
 src/spy/libpcscspy.c   | 2 +-
 3 files changed, 4 insertions(+), 4 deletions(-)

commit eab1d67295e4e1d5c12bbca77bc57c50fd384a4e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jan 18 16:58:29 2017 +0100

    pcsc_stringify_error(): use Thread-local storage
    
    " The pcsc_stringify_error() function in the PC/SC-Lite implementation
    uses a statically allocated buffer. This means that the buffer may be
    used simultaneously when the function is called from multiple threads
    concurrently.
    Therefore, the returned message may be spoiled, e.g.:
    "Internal error.ul"
    or
    "Command cancell"
    In the worst-case scenario, the application may read an unbounded
    string (with the terminating null character missing). "
    
    Thanks to Maksim Ivanov fro the bug report
    "[Pcsclite-muscle] pcsc_stringify_error thread safety"
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000781.html
    
    and Ivo Raisr (and Nikos Mavrogiannopoulos) for the solution
    "[Pcsclite-muscle] pcsc_stringify_error thread safety"
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20170116/000782.html

 src/error.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 980fdc357bc36e3f608462a1d7bcb182b1bacdae (tag: pcsc-1.8.20)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Dec 30 18:10:07 2016 +0100

    Release 1.8.20

 ChangeLog    | 5 +++++
 configure.ac | 2 +-
 2 files changed, 6 insertions(+), 1 deletion(-)

commit 3aaab9d998b5deb16a246cc7517e44144d281d3b
Author: Peter Wu <peter@lekensteyn.nl>
Date:   Sun Dec 25 23:37:51 2016 +0100

    SCard: check for a valid hContext handles
    
    Reject invalid (zero) hContext handles and log the event.

 src/winscard_svc.c | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 697fe05967af7ea215bcd5d5774be587780c9e22
Author: Peter Wu <peter@lekensteyn.nl>
Date:   Sun Dec 25 23:31:24 2016 +0100

    SCardReleaseContext: prevent use-after-free of cardsList
    
    Once MSGRemoveContext is invoked (via SCARD_RELEASE_CONTEXT),
    cardsList is freed. A repeated invocation of SCARD_RELEASE_CONTEXT (with
    an empty context handle) results in a use-after-free followed by a
    double-free.
    
    After MSGRemoveContext, invocation of SCardEstablishContext enable
    further use-after-free of cardsList in MSGCheckHandleAssociation,
    MSGRemoveContext, MSGAddHandle, MSGRemoveHandle.
    
    To avoid this problem, destroy the list only when the client connection
    is terminated.

 src/winscard_svc.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit c10dac9ce97ed3fda204fd73ef1f19ac4446426d (tag: pcsc-1.8.19)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Dec 9 10:07:52 2016 +0100

    Release 1.8.19

 ChangeLog    | 12 ++++++++++++
 configure.ac |  2 +-
 2 files changed, 13 insertions(+), 1 deletion(-)

commit 152a53e5151f4f81c572dfeae02d5e0ea8eebccf
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Dec 8 14:48:21 2016 +0100

    SCardGetStatusChange(): Fix the fix for a race condition
    
    The change in 4e2a563c8ed4353ad013de85b71aac12ec599f82 is not correct.
    
    WRITE_BODY() is a macro composed of 2 lines of C so we can't use:
    "if (test)
        WRITE_BODY()"
    
    As is is interpreted as:
    "if (test)
        instruction1;
    instruction2;"
    
    For that to work we need to:
    - use { } around WRITE_BODY()
    or
    - define WRITE_BODY() as a C instruction
    
    Defining WRITE_BODY() as a C instruction (a "do {} while(0)") is the
    best option as it will prevent the same bug to appear again.
    
    Thanks to Florian Kaiser (again) for the patch
    "[Pcsclite-muscle] [PATCH] fix racecondition between winscard server and
    clients"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20161205/000775.html

 src/winscard_svc.c | 82 ++++++++++++++++++++++++++++++------------------------
 1 file changed, 45 insertions(+), 37 deletions(-)

commit 4e2a563c8ed4353ad013de85b71aac12ec599f82
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Dec 6 16:47:43 2016 +0100

    SCardGetStatusChange(): Fix a (rare) race condition
    
    " After the client timed out it sends a CMD_STOP_WAITING_READER_STATE_CHANGE.
    Sometimes an event occurs which triggers MSGSignalClient, which unregisters the
    client from events and sends a wait_reader_state_change message to the client.
    The client interprets this message as an answer to its
    CMD_STOP_WAITING_READER_STATE_CHANGE.
    
    If we send another wait_reader_state_change message to the client it stays in
    its buffer until another Command is issued and this message appears as leading
    garbage in the commands answer.
    
    Therefore we should not send the wait_reader_state_change message here, if the
    client has already been unregisterd from events. "
    
    Thanks to Florian Kaiser for the patch
    "[Pcsclite-muscle] [PATCH] fix racecondition between winscard server and clients"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20161128/000772.html

 src/winscard_svc.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 93fee94dcd6acc77b1f962aa20be244e3c39a75f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Dec 3 19:51:55 2016 +0100

    ContextThread(): Fix comment
    
    Thanks to Florian Kaiser for the patch
    "[Pcsclite-muscle] [PATCH] fix racecondition between winscard server and
    clients"
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20161128/000772.html

 src/winscard_svc.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b703805510b814b78967c7e84ad3a477cb8fc10e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Nov 24 16:43:25 2016 +0100

    pcsc-spy: log the thread number in the results
    
    The "Results sorted by total execution time" are displayed for each
    thread found. Now the thread index is also displayed to make it more
    explicit why different results are displayed.
    
    We now have something like:
    Thread 1/3
    Results sorted by total execution time
    total time: 0.002176 sec
    0.000554 sec (  2 calls) 25.46% SCardListReaders
    0.000529 sec (  3 calls) 24.31% SCardConnect
    0.000251 sec (  1 calls) 11.53% SCardEstablishContext
    0.000196 sec (  3 calls)  9.01% SCardDisconnect
    0.000081 sec (  1 calls)  3.72% SCardReleaseContext
    
    Thread 2/3
    Results sorted by total execution time
    total time: 0.002176 sec
    0.000720 sec (  3 calls) 33.09% SCardConnect
    0.000390 sec (  2 calls) 17.92% SCardListReaders
    0.000250 sec (  3 calls) 11.49% SCardDisconnect
    0.000177 sec (  1 calls)  8.13% SCardEstablishContext
    0.000065 sec (  1 calls)  2.99% SCardReleaseContext
    
    Thread 3/3
    Results sorted by total execution time
    total time: 0.002176 sec
    0.000499 sec (  3 calls) 22.93% SCardConnect
    0.000456 sec (  1 calls) 20.96% SCardEstablishContext
    0.000347 sec (  2 calls) 15.95% SCardListReaders
    0.000275 sec (  3 calls) 12.64% SCardDisconnect
    0.000050 sec (  1 calls)  2.30% SCardReleaseContext
    
    Thanks to Oliver Graute for the "bug" request
    "[Pcsclite-muscle] High CPU load with pcscd and Kerkey security Module"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20161121/000766.html

 src/spy/pcsc-spy | 4 ++++
 1 file changed, 4 insertions(+)

commit 5c7f9665358b55d320cfefb2276348a53a59da33
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Nov 16 14:34:39 2016 +0100

    Doxygen: Revert SCardConnect() within a transaction
    
    It looks like this difference is NOT confirmed.
    
    Thanks to Michael Traut for the update.
    "[Pcsclite-muscle] Difference from Windows' implementation with regard
    to PC/SC shared mode"
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20161024/000743.html

 src/winscard_clnt.c | 6 ------
 1 file changed, 6 deletions(-)

commit dd69aff59f46a81b3ec2b971e30889056aee7ee0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Nov 15 09:43:31 2016 +0100

    Doxygen: improve IFDHGetCapabilities() documentation
    
    Document the expected returned values.

 src/PCSC/ifdhandler.h | 17 ++++++++++++-----
 1 file changed, 12 insertions(+), 5 deletions(-)

commit aa9db5f12b892c94585452fc106d48f064bc0f60
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Oct 26 12:06:15 2016 +0200

    Doxygen: document SCardConnect() within a transaction
    
    SCardConnect() does not behave as on Windows when a transaction is
    running.
    
    Thanks to Maksim Ivanov for the "bug" report
    "[Pcsclite-muscle] Difference from Windows' implementation with regard
    to PC/SC shared mode"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20161017/000738.html

 src/winscard_clnt.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 45dd695d05742b039384951e130570aed289d7ca
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Oct 19 18:38:18 2016 +0200

    pcsc-spy: fix display of execution time
    
    The execution time is displayed in seconds and micro-seconds.
    1 micro-second is 10E-6 second, not 10E-9.

 src/spy/pcsc-spy | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f42ec9361bde72e738885856b2f534022c013671
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 28 09:54:49 2016 +0200

    Doxygen: add a link to the "differences" chapter
    
    It is now possible to easily reference the "Known differences with
    Microsoft Windows WinSCard implementation" chapter.
    
    The URL is
    http://pcsclite.alioth.debian.org/api/group__API.html#differences

 src/winscard_clnt.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit db9d22e3a38e713d8150b5fddc124cc57c4e89e9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 28 09:28:12 2016 +0200

    Doxygen: SCARD_E_NOT_READY is never returned
    
    SCardConnect() and SCardReconnect() will never return SCARD_E_NOT_READY.
    So remove this return value from the Doxygen documentation.
    
    In fact SCARD_E_NOT_READY is not used by any pcsc-lite function.

 src/winscard_clnt.c | 2 --
 1 file changed, 2 deletions(-)

commit 00c5acb113b5b96226f6d791da6ee6e31c948137
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Aug 23 19:13:50 2016 +0200

    pcscd: do not check the process is setuid to limit rights
    
    pcscd is no more installed as setuid or setgid to allow auto start.
    "Configuring your system for pcscd auto-start"
    https://ludovicrousseau.blogspot.fr/2010/12/configuring-your-system-for-pcscd-auto.html
    
    pcscd is now started on demand as root by systemd
    "pcscd auto start using systemd"
    https://ludovicrousseau.blogspot.fr/2011/11/pcscd-auto-start-using-systemd.html
    
    It is no more needed to check pcscd is setuid/setgid to limit its
    possibilities.
    
    The change was made in cac146d23b899c46e9db7f6409a905e115ef921f (Aug 16
    2010) and is not reverted.

 src/pcscdaemon.c | 20 --------------------
 1 file changed, 20 deletions(-)

commit da8448b4effeb607f173233e725214275795a7a4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Aug 23 19:08:23 2016 +0200

    ChangeLog: convert to UTF-8
    
    The file was using Latin-1 or ISO-8859 encoding.

 ChangeLog | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 29ead37d5b4e41178a30fb390f64a51de98ff547
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 25 14:51:41 2016 +0200

    winscard.h: fix SCardGetStatusChange() prototype
    
    Use "SCARD_READERSTATE *" instead of "LPSCARD_READERSTATE" for the
    rgReaderStates parameter to match the definition of
    SCardGetStatusChange() in winscard_clnt.c.
    
    The Doxygen page for winscard.h now does point to the documentation of
    SCardGetStatusChange().
    
    Even if the 2 types are, in fact, the same Doxygen was confused.

 src/PCSC/winscard.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0cd6b659868fd7eccc0c1c20e67623cf6e32edba
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 25 14:48:01 2016 +0200

    Doxygen: SCardGetStatusChange() may return SCARD_E_UNKNOWN_READER
    
    Document that SCARD_E_UNKNOWN_READER is a possible return value.
    
    Thanks to Maksim Ivanov for the bug report
    "[Pcsclite-muscle] Small doc improvement for SCardGetStatusChange"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160822/000697.html

 src/winscard_clnt.c | 1 +
 1 file changed, 1 insertion(+)

commit f9971f6577997929be74f2feb708e09121db6aaa
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 25 10:11:25 2016 +0200

    Fix capitalisation issues in license text
    
    All the licence text was in lower case.
    I guess that was because of a wrong manupilation of vim.

 UnitaryTests/stress_apdu.py         | 16 ++++++++--------
 UnitaryTests/stress_get_firmware.py | 16 ++++++++--------
 2 files changed, 16 insertions(+), 16 deletions(-)

commit 12ed49c6130da8e0365db02b289feb99b54d1d96 (tag: pcsc-1.8.18)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Aug 10 20:33:07 2016 +0200

    Release 1.8.18

 ChangeLog    | 9 +++++++++
 configure.ac | 2 +-
 2 files changed, 10 insertions(+), 1 deletion(-)

commit daae836ffc4a8ac0199a1aa16a0282806cbd4af4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 5 16:44:51 2016 +0200

    SCardDisconnect(): fix compiler warnings
    
    winscard.c: In function ‘SCardDisconnect’:
    winscard.c:912:5: warning: format ‘%d’ expects argument of type ‘int’, but argument 6 has type ‘LONG’ [-Wformat=]
         Log3(PCSC_LOG_ERROR, "Error powering down card: %d 0x%04X",
         ^
    winscard.c:912:5: warning: format ‘%X’ expects argument of type ‘unsigned int’, but argument 7 has type ‘LONG’ [-Wformat=]

 src/winscard.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b25f2d5a3822b9eed4f64f3052e54230af292af2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 5 16:23:20 2016 +0200

    SCardDisconnect(): much faster SCARD_UNPOWER_CARD
    
    When SCardDisconnect() is used with SCARD_UNPOWER_CARD we just power
    down the card and do not power it up again.
    
    The idea is to be faster and gain some milliseconds.
    The code to power up the card on demand was already present since 2010
    with the card auto power on and off mechanism.
    
    Before the change: SCardDisconnect(SCARD_UNPOWER_CARD) in 61 ms
    After the change: SCardDisconnect(SCARD_UNPOWER_CARD) in 1.4 ms
    
    Improvement factor (for the card used) = 61/1.4 = x44
    
    If you use a card that is slower to power up then the gain is even higher.
    
    Thanks to Christophe Ferrando from Sylyca for the patch.

 src/winscard.c | 22 +---------------------
 1 file changed, 1 insertion(+), 21 deletions(-)

commit a8358bc84be4c8870cb4955f4e106f4d46740cfd
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 5 16:16:13 2016 +0200

    SCardConnect(): do not use a local readerState
    
    We do want to change the value of rContext->readerState->readerState after
    the power up, not just the value of the local copy.
    
    I am not sure the code was broken but it will help make the next patch
    work.

 src/winscard.c | 9 +++------
 1 file changed, 3 insertions(+), 6 deletions(-)

commit 7084732383a7d97caf50350b4b0b95d9c22f42ee
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 4 11:46:24 2016 +0200

    cleanup: remove unused function from configure.ac
    
    Some system functions presence where tested using AC_CHECK_FUNCS() but
    the functions were no more used in the code.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4882c37ab7df63be7090addf936e1b795467ab75
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 4 11:43:59 2016 +0200

    cleanup: remove unused headers from sys_unix.c

 src/sys_unix.c | 12 ------------
 1 file changed, 12 deletions(-)

commit 3a4134432613e73baa8cbe2206f4e2a365c356ca
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 4 11:39:51 2016 +0200

    Doxygen: add documentation for SYS_RandomInt()

 src/sys_unix.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit d62561e1baaaa2a1138caf243994aef09931bfcd
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 4 11:31:15 2016 +0200

    cleanup: remove declaration of SYS_Daemon()
    
    SYS_Daemon() code was removed in 12f1f0e4ff330bacc28254519293bf0e3e1fd047
    (June 2010) but its declaration was still present in sys_generic.h

 src/sys_generic.h | 2 --
 1 file changed, 2 deletions(-)

commit 8e820796b338cb1048c51ec462446f61a3979835
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 4 11:29:49 2016 +0200

    main(): Init the PRNG from a safe place
    
    The PRNG init is now done before any client can connect to the daemon.
    
    Thanks to Maksim Ivanov for the idea
    "[Pcsclite-muscle] Possible generation of duplicate SCARDHANDLE"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160801/000686.html

 src/pcscdaemon.c | 3 +++
 1 file changed, 3 insertions(+)

commit 8b80aa4900cd60ab075802bdcc5a996027d0c74e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 4 11:23:37 2016 +0200

    SYS_InitRandom(): new function to init the PRNG
    
    The Pseudo Random Number Generator now has an independent function to
    initialize its internal state.
    
    The PRNG init was done in the first call to SYS_RandomInt().
    A problem could appear when SYS_RandomInt() is called for the first time
    at the same time from 2 clients.
    
    Thanks to Maksim Ivanov for the idea
    "[Pcsclite-muscle] Possible generation of duplicate SCARDHANDLE"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160801/000686.html

 src/sys_generic.h |  2 +-
 src/sys_unix.c    | 15 ++++++---------
 2 files changed, 7 insertions(+), 10 deletions(-)

commit bb07a905c896e7a67e3d7b37a24b3637ada0546d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 4 11:00:04 2016 +0200

    SCardConnect(): Fix a possible duplicated hCard context
    
    It was possible for 2 applications to call SCardConnect() at the same
    time and that the same random hCard handle is generated and used for
    the 2 applications.
    
    The solution is to serialize the 2 generations of hCard handles. The
    second randomly generated handle will be found as already used and
    another handle will be generated.
    
    Thanks to Maksim Ivanov for the bug report
    "[Pcsclite-muscle] Possible generation of duplicate SCARDHANDLE"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160801/000673.html

 src/winscard.c | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit e34065edb88c14e16248e1c266d2f499a6476935
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 30 16:56:15 2016 +0200

    FEATURE_GET_TLV_PROPERTIES.py: update copyright date

 UnitaryTests/FEATURE_GET_TLV_PROPERTIES.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8bdfcd57dfcf9c062a3ab99a859acdcb7cd2db5a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 30 16:55:39 2016 +0200

    FEATURE_GET_TLV_PROPERTIES.py: for each reader
    
    Display the properties for each connected reader.

 UnitaryTests/FEATURE_GET_TLV_PROPERTIES.py | 30 +++++++++++++++++-------------
 1 file changed, 17 insertions(+), 13 deletions(-)

commit b136ffd7e2cf543184504c7e14f90036b0275643
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 30 16:53:15 2016 +0200

    FEATURE_GET_TLV_PROPERTIES.py: remove extra import
    
    Do not import symbols not used.

 UnitaryTests/FEATURE_GET_TLV_PROPERTIES.py | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit e78449ce37f453516e46d78ad0b99e01db32727b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jun 17 22:21:01 2016 +0200

    ThreadCreate(): fix stack size on Solaris
    
    A stack_size of 0 indicates the default size on Solaris.
    The default size is 2 MB so more than 256 KB. Do not shrink it.
    
    Thanks to Ivo Raisr for the bug report.

 src/utils.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit d707446143114f579e78e5d652946f142e28847a
Author: Richard PALO <richard@NetBSD.org>
Date:   Wed Jun 1 07:15:22 2016 +0200

    configfile.l: Fix issue on SunOS
    
    Update HAVE_STRUCT_DIRENT guard.
    The previous patch fa52ae4e1f1ae3c35596e9aedaa3ce30fc5ceef9 was not
    correct.

 src/configfile.l | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ab23479d27d32d0b62c609997e14c38fef6e5928
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue May 31 20:17:10 2016 +0200

    Fix compilation on FreeBSD: alloca.h does not exist
    
    On FreeBSD alloca.h does not exist and alloca(3) is declared in
    stdlib.h (already included by src/readerfactory.c).
    
    Thanks to Tilman Keskinoz for the bug report.

 configure.ac        | 2 +-
 src/readerfactory.c | 4 +++-
 2 files changed, 4 insertions(+), 2 deletions(-)

commit f74dc1feea4c7a2345abb3e1861b350d46946c86 (tag: pcsc-1.8.17)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun May 29 14:11:21 2016 +0200

    Release 1.8.17

 ChangeLog    | 11 +++++++++++
 configure.ac |  2 +-
 2 files changed, 12 insertions(+), 1 deletion(-)

commit 0ba8145d814b846f2f2c2c59ad82e34f1253159a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri May 27 18:57:19 2016 +0200

    Doxygen: improve SCardGetStatusChange example
    
    Show how to wait for a card insertion.

 src/winscard_clnt.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 687128ad9a377a27bd93e542fc096530534dc101
Author: Richard PALO <richard@NetBSD.org>
Date:   Sat Apr 23 18:13:37 2016 +0200

    Fix SunOS compilation error
    
    Avoid visibility issues on SunOS on either gcc or studio
    by using a guard stipulating minimum versions for each compiler
    needed to support __attribute__((visibility("hidden")) or equivalent

 src/misc.h | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 9be0451909b73a4f52e42c01915683954d7d0a84
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat May 7 11:54:14 2016 +0200

    Fix end of function comment

 src/debuglog.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f3a6ccac63abd4d7d0e4eeced059128919286bab
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri May 20 17:07:03 2016 +0200

    Unit Test for 74656f24
    
    SCardEndTransaction(): no card action in a transaction

 UnitaryTests/SCardBeginTransaction_Reset.py | 85 +++++++++++++++++++++++++++++
 1 file changed, 85 insertions(+)

commit 74656f24db3da1532040a1775ceffa225fbc3d00
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri May 20 17:02:40 2016 +0200

    SCardEndTransaction(): no card action in a transaction
    
    If a transaction is ongoing then another SCardEndTransaction() should
    not reset or unpower the card.
    In that case SCARD_E_SHARING_VIOLATION is returned and the transaction
    is not ended.

 src/winscard.c | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit b7a4f8f47c1c57b56dfe6cd1088f68b845016d9b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri May 20 16:19:56 2016 +0200

    RFUnlockSharing: handle SCARD_SHARE_EXCLUSIVE
    
    When a card is connected using SCARD_SHARE_EXCLUSIVE then
    RFUnlockSharing() called by SCardEndTransaction() should not be able to
    remove the exclusive access.
    
    The bug was detected because the following sequence worked but should
    not:
    SCardConnect(..., SCARD_SHARE_EXCLUSIVE, ...);
    SCardEndTransaction();
    
    An error was reported only on the second SCardEndTransaction() call.
    
    Now the first call to SCardEndTransaction() will fail and the card
    connection will stay exclusive.
    
    Thanks to Christophe Ferrando for the bug report in "[Pcsclite-muscle]
    SCARD_E_NOT_TRANSACTED"
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160516/000598.html

 src/readerfactory.c | 22 ++++++++++++++++------
 1 file changed, 16 insertions(+), 6 deletions(-)

commit 88b2085b9c60c7a99aa1306187ad77ce1670a8eb
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri May 20 15:39:20 2016 +0200

    SCardGetAttrib.py: display the values in ASCII
    
    Display the attributes values also in ASCII.
    
    The output is now something like:
    PC/SC Readers: ['Gemalto PC Twin Reader (70D7E2EE) 00 00']
    reader: Gemalto PC Twin Reader (70D7E2EE) 00 00
    0x10103 [55, 48, 68, 55, 69, 50, 69, 69, 0] 37 30 44 37 45 32 45 45 00
    70D7E2EE
    0x90303 [59, 167, 0, 64, 24, 128, 101, 162, 8, 1, 1, 82] 3B A7 00 40 18
    80 65 A2 08 01 01 52 ;�@�eR

 UnitaryTests/SCardGetAttrib.py | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b1effd21528d27dfa016c2752cf3e4cb973240f4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Apr 22 15:45:01 2016 +0200

    pcscd.h.in: remove extra spaces

 src/pcscd.h.in | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 77740786d5450273fad1400322918f5a276b3131
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Apr 25 11:31:44 2016 +0200

    SCardGetAttrib.py: also use SCARD_ATTR_ATR_STRING
    
    Try to use both attributes SCARD_ATTR_VENDOR_IFD_SERIAL_NO and
    SCARD_ATTR_ATR_STRING
    
    Not all devices have a serial number so SCARD_ATTR_VENDOR_IFD_SERIAL_NO
    may just return an empty buffer.
    
    SCARD_ATTR_ATR_STRING should always work when a card is inserted (and
    the CCID driver is used).

 UnitaryTests/SCardGetAttrib.py | 18 ++++++++++++------
 1 file changed, 12 insertions(+), 6 deletions(-)

commit fa52ae4e1f1ae3c35596e9aedaa3ce30fc5ceef9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Apr 24 19:04:04 2016 +0200

    Fix use of d_type field on SunOS
    
    SunOS does not provide the d_type field in a directory entry.
    
    The code now checks that d_type is available using
    AC_STRUCT_DIRENT_D_TYPE and use it conditionnaly.
    
    Fix compilation error on SunOS:
    configfile.l: In function 'DBGetReaderListDir':
    configfile.l:293:16: error: 'struct dirent' has no member named 'd_type'
        if (direntry->d_type == DT_UNKNOWN)
                    ^
    configfile.l:293:28: error: 'DT_UNKNOWN' undeclared (first use in this function)
        if (direntry->d_type == DT_UNKNOWN)
                                ^
    configfile.l:293:28: note: each undeclared identifier is reported only once for each function it appears in
    configfile.l:312:17: error: 'struct dirent' has no member named 'd_type'
         if (direntry->d_type != DT_REG)
                     ^
    configfile.l:312:29: error: 'DT_REG' undeclared (first use in this function)
         if (direntry->d_type != DT_REG)
                                 ^
    
    Thanks to risto3 for the bug report
    https://github.com/LudovicRousseau/PCSC/issues/6

 configure.ac     | 1 +
 src/configfile.l | 4 ++++
 2 files changed, 5 insertions(+)

commit 88acbfa03b98f28567c2438ea7aca6447488c0af
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Apr 24 18:55:45 2016 +0200

    Fix compiler warnings on SunOS
    
    utils.c: In function 'SendHotplugSignal':
    utils.c:97:3: warning: format '%d' expects argument of type 'int', but argument 6 has type 'pid_t' [-Wformat=]
       Log2(PCSC_LOG_INFO, "Send hotplug signal to pcscd (pid=%d)", pid);
       ^
    utils.c:100:4: warning: format '%d' expects argument of type 'int', but argument 6 has type 'pid_t' [-Wformat=]
        Log3(PCSC_LOG_CRITICAL, "Can't signal pcscd (pid=%d): %s",
        ^

 src/utils.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 2360debebf1c35c8599cd2e0fc484e5f5029ab87
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Apr 24 18:52:45 2016 +0200

    Fix compiler warning on SunOS
    
    pcscdaemon.c: In function 'main':
    pcscdaemon.c:402:5: warning: format '%d' expects argument of type 'int', but argument 6 has type 'pid_t' [-Wformat=]
         Log2(PCSC_LOG_CRITICAL,
         ^

 src/pcscdaemon.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit abe436e38aa58cb1140eff0d497ba721474c7703
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Apr 24 18:46:53 2016 +0200

    Fix signal handler by using only allowed functions
    
    The signals are now treated in a special thread created just for that purpose.
    
    Thanks to Andre Florath for the bug report
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160404/000561.html
    
    [Pcsclite-muscle] pcscd jams when using '--auto-exit'
    
    Andre Florath andre at florath.net
    Sat Apr 9 06:06:44 UTC 2016
    
    Hello!
    
    Since some time I have problems with pcscd. I'm using pcscd in
    conjunction with online banking and after a short period of working it
    stops and jams the banking application.
    
    A 'strace' to the pcscd showed that it is still running somewhere
    deep in the USB stack.
    
    The problem is, when manually running the the pcscd, there is no
    problem at all - only when running from systemd.
    Therefore I searched for the differences and found one: the
    '--auto-exit'. Downloaded the source and had a closer look.
    
    What I understand from the source code is, that when '--auto-exit' is
    given, a SIGALRM is generated which (should) terminate the process.
    
    I have noticed that the signal handler 'signal_trap()' uses some
    function calls that are not allowed in signal handlers; like:
    * syslog()
    * gettimeofday()
    * remove()
    
    Using this creates undefined behavior.
    (Please see 'man 7 signal' for a complete list of system calls that
    are not allowed in signal handlers.)
    
    I found a workaround for the issue.
    Changed the service file to:
    
    ===
    [Unit]
    Description=PC/SC Smart Card Daemon
    
    [Service]
    ExecStart=/usr/sbin/pcscd --foreground --debug -a
    ExecReload=/usr/sbin/pcscd --hotplug
    
    [Install]
    Also=pcscd.socket
    ===
    
    and disabling the pcscd.socket gives me a stable system.
    (Yes - pcscd is now started at boot time and runs the whole time
     - which is fine for me.)
    
    If you need more information, please drop me a note.
    
    Kind regards
    
    Andre

 src/pcscdaemon.c | 170 ++++++++++++++++++++++++++++++++++++-------------------
 1 file changed, 111 insertions(+), 59 deletions(-)

commit b48ff146f979cd3323845e1c19d1c1629d2ae037
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Apr 24 18:25:03 2016 +0200

    Check alloca(3) is available
    
    The code uses alloca(3) so we check in ./configure that this function is
    available.

 configure.ac | 1 +
 1 file changed, 1 insertion(+)

commit 890f7edbd931467fd381739257ac1e1f335eb64a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Apr 23 15:57:46 2016 +0200

    readerfactory: fix compilation warning on SunOS
    
    The code uses alloca() so we #include "alloca.h"
    
    readerfactory.c: In function 'RFAddReader':
    readerfactory.c:211:2: warning: implicit declaration of function 'alloca' [-Wimplicit-function-declaration]
      readerName = alloca(strlen(readerNameLong)+1);
      ^
    readerfactory.c:211:15: warning: incompatible implicit declaration of built-in function 'alloca'
      readerName = alloca(strlen(readerNameLong)+1);
                   ^

 src/readerfactory.c | 1 +
 1 file changed, 1 insertion(+)

commit 2269f10c2d2c5be1308d59469722024650a19b6d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Apr 13 18:29:53 2016 +0200

    SCardConnect(): fix a Valgrind warning
    
    ==19635== Memcheck, a memory error detector
    ==19635== Copyright (C) 2002-2012, and GNU GPL'd, by Julian Seward et al.
    ==19635== Using Valgrind-3.8.1 and LibVEX; rerun with -h for copyright info
    ==19635== Command: /usr/rtests/bin/Pkcs11UnitTest.X64 pkcs11_common
    ==19635==
    Running pkcs11_common
    pkcs11_common::testGetInfo==19635== Syscall param socketcall.sendto(msg) points to uninitialised byte(s)
    ==19635== at 0x605A1F7: send (send.c:32)
    ==19635== by 0xBC47CE6: ??? (in /lib/x86_64-linux-gnu/libpcsclite.so.1.0.0)
    ==19635== by 0xBC47E22: ??? (in /lib/x86_64-linux-gnu/libpcsclite.so.1.0.0)
    ==19635== by 0xBC43BBE: SCardConnect (in /lib/x86_64-linux-gnu/libpcsclite.so.1.0.0)
    ...
    
    The field scConnectStruct.szReader (containing the reader name) was not
    completely initialized.
    
    Thanks to Andrey Roussev for the patch
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160404/000560.html

 src/winscard_clnt.c | 1 +
 1 file changed, 1 insertion(+)

commit d6c7215335fe04abfd91206349c7d674de7bfcaa
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Mar 31 16:43:16 2016 +0200

    Doxygen: SCardGetAttrib() *pcbAttrLen contains the buffer size
    
    On return *pcbAttrLen contains the actual length of the received
    attribute.
    
    If the buffer was not big enough the error SCARD_E_INSUFFICIENT_BUFFER
    is returned and *pcbAttrLen contains the expected size.

 src/winscard_clnt.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit e64629f80a4639836399493ef5c3c717571ffc96
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Mar 31 16:11:44 2016 +0200

    SCardGetAttrib(): set pcbAttrLen when buffer is too small
    
    When the user provides a pbAttr[] buffer too small then the error code
    SCARD_E_INSUFFICIENT_BUFFER is returned and the correct buffer size
    value is set in pcbAttrLen.
    
    Before the change the value of pcbAttrLen was not changed so the user
    had no idea what the correct value should be.

 src/winscard_clnt.c | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

commit 84a9441d52e72e1fbec6aa2b0dd6db27d3f5ce38
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Mar 31 11:42:39 2016 +0200

    Doxygen: SCardGetAttrib() pbAttr can be NULL
    
    If pbAttr is NULL then the correct buffer size is indicated in
    pcbAttrLen.
    
    Also modify the example to use the double call.

 src/winscard_clnt.c | 17 +++++++++++++----
 1 file changed, 13 insertions(+), 4 deletions(-)

commit 55fa57fc691b732535fc3384a214b1daa133a127 (tag: pcsc-1.8.16)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Mar 20 16:57:30 2016 +0100

    Release 1.8.16

 ChangeLog    | 13 +++++++++++++
 configure.ac |  2 +-
 2 files changed, 14 insertions(+), 1 deletion(-)

commit f017742e379668d37fe7f9a054cdd4168fde51a8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Mar 20 16:56:40 2016 +0100

    Fix compiler warning
    
    dyn_macosx.c:115:6: warning: unused parameter 'mayfail' [-Wunused-parameter]
            int mayfail)
                ^

 src/dyn_macosx.c | 1 +
 1 file changed, 1 insertion(+)

commit 4d7abdeff7808b1ab545a98733282d421e751a0e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Mar 20 16:47:05 2016 +0100

    dyn_*: Fix compiler warnings
    
    DYN_* functions now return a LONG instead of an int
    
    dyn_unix.c:59:10: warning: implicit conversion from 'LONG' (aka 'long') to 'int'
          changes value from 2148532244 to -2146435052 [-Wconstant-conversion]
                    return SCARD_F_UNKNOWN_ERROR;
                    ~~~~~~ ^~~~~~~~~~~~~~~~~~~~~
    ../src/PCSC/pcsclite.h:147:33: note: expanded from macro 'SCARD_F_UNKNOWN_ERROR'
                                             ^~~~~~~~~~~~~~~~
    dyn_unix.c:77:10: warning: implicit conversion from 'LONG' (aka 'long') to 'int'
          changes value from 2148532244 to -2146435052 [-Wconstant-conversion]
                    return SCARD_F_UNKNOWN_ERROR;
                    ~~~~~~ ^~~~~~~~~~~~~~~~~~~~~
    ../src/PCSC/pcsclite.h:147:33: note: expanded from macro 'SCARD_F_UNKNOWN_ERROR'
                                             ^~~~~~~~~~~~~~~~
    dyn_unix.c:105:8: warning: implicit conversion from 'LONG' (aka 'long') to 'int'
          changes value from 2148532244 to -2146435052 [-Wconstant-conversion]
                    rv = SCARD_F_UNKNOWN_ERROR;
                       ~ ^~~~~~~~~~~~~~~~~~~~~
    ../src/PCSC/pcsclite.h:147:33: note: expanded from macro 'SCARD_F_UNKNOWN_ERROR'
                                             ^~~~~~~~~~~~~~~~

 src/dyn_generic.h | 6 +++---
 src/dyn_hpux.c    | 6 +++---
 src/dyn_unix.c    | 8 ++++----
 3 files changed, 10 insertions(+), 10 deletions(-)

commit 152746d73149dff6218667b83b053233f2d3d476
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 18 13:43:58 2016 +0100

    linux hotplug: handle error in parsing drivers
    
    The error returned by HPReadBundleValues() was not checked in
    HPSearchHotPluggables().
    
    We now check that at least 1 driver has been found before starting the
    notification thread.
    
    Thanks to Maksim Ivanov for the bug report
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160314/000550.html

 src/hotplug_linux.c | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit 9d0438ae384c33276d671cdf0830fe5d51901192
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 18 13:29:35 2016 +0100

    libusb hotplug: handle error in parsing drivers
    
    If HPReadBundleValues() returned an error (-1) it was considered as a
    correct value in HPSearchHotPluggables()
    
    We now check that at least 1 driver has been found.
    
    Thanks to Maksim Ivanov for the bug report
    https://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160314/000550.html

 src/hotplug_libusb.c | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit 6cd24b9c83513c207cff39afbf9b653cbf8d004a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 16:25:57 2016 +0100

    Doxygen: improve documentation
    
    Thanks to Maksim Ivanov for the bug report
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000545.html

 src/winscard_clnt.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit f3adfd0dc4d8047d0a52c6f6270be74a4df82e9a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 16:17:58 2016 +0100

    Doxygen: improve SCardGetAttrib() documentation
    
    SCardGetAttrib() can also return:
    - SCARD_E_UNSUPPORTED_FEATURE the dwAttrId attribute is not supported by
      the driver
    - SCARD_E_NOT_TRANSACTED the driver returned an error

 src/winscard_clnt.c | 2 ++
 1 file changed, 2 insertions(+)

commit f649b29424dc55c63c8bbf7c6006e3cb2cb686e2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 11:49:12 2016 +0100

    Unitary test for SCardCancel
    
    Test the bug fix in 57b0ba5a200bcbf1c489d39261340324392a8e8a

 UnitaryTests/SCardCancel3.py | 96 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 96 insertions(+)

commit 57b0ba5a200bcbf1c489d39261340324392a8e8a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 11:40:09 2016 +0100

    SCardCancel was not correctly handled
    
    When a SCardGetStatusChange() was cancelled then a next PC/SC call
    after the SCardGetStatusChange() may fail with a strange error code if
    the event waited in SCardGetStatusChange() occurs.
    
    " Looks like there is a bug related to the management of the blocking
    requests and of their cancellation.
    
    The reproduce steps are the following. Two threads: thread 1 and
    thread 2. Thread 2 calls SCardGetStatusChange and blocks (with waiting
    for some event X). Thread 1 calls SCardCancel. Thread 2 unblocks from
    SCardGetStatusChange due to the cancellation, and starts issuing other
    PC/SC-Lite API calls. After that, something that triggers the event X
    happens. After that the PC/SC-Lite API calls that thread 2 is making
    start to break (they return inconsistent results).
    
    The underlying reason is that cancellation in the current
    implementation of the PC/SC-Lite service does not unsubscribe the
    client from the list of clients waiting for events. So, when the event
    finally occurs, the event response is written into the client's
    socket, even if the cancellation had already happened before. Putting
    unexpected data into the socket shifts the responses of all further
    PC/SC-Lite API calls made by that client.
    
    If the analysis above is correct, then the correct fix would be
    probably just adding a "EHTryToUnregisterClientForEvent(fd)" statement
    into the handler of the SCARD_CANCEL message in function ContextThread
    (file winscard_svc.c). "
    
    Thanks to Maksim Ivanov for the bug report and patch
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000538.html

 src/winscard_svc.c | 4 ++++
 1 file changed, 4 insertions(+)

commit ea0a50bf2088906d888cf1888b4439f3391eb111
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 10:36:56 2016 +0100

    Enable Trace and Profile features using compiler flags
    
    " I have a couple of small suggestions regarding the tracing feature of
    the PC/SC-Lite's client side library. This feature is controlled by
    the "DO_TRACE" preprocessor definition.
    
    First, it's impossible to trigger this feature using the compiler
    flags: for some reason, the winscard_clnt.c file contains directive
    "#undef DO_TRACE". If it were a commented "#define" directive, then
    this would be more useful: the feature could be triggered both by
    editing the source file and by modifying the compiler flags. "
    
    The code now uses
    //#define DO_TRACE
    instead of
    
    It is now possible to enable this feature using the compiler flag
    -DDO_TRACE without modifying the source code.
    
    Same thing for DO_PROFILE.
    
    Thanks to Maksim Ivanov for the bug idea
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000537.html

 src/winscard_clnt.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 43bac6981940ae3e8f05122342df6515aacb7fe8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 10:24:59 2016 +0100

    Doxygen: fix SCardListReaderGroups() documentation
    
    The error code SCARD_E_INVALID_PARAMETER is returned if mszGroups is
    NULL _and_ *pcchGroups == SCARD_AUTOALLOCATE.
    
    Having mszGroups == NULL is the normal way to get the string size in the
    pcchGroups parameter.
    
    Thanks to Maksim Ivanov for the bug report
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000536.html

 src/winscard_clnt.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit aed8486d13da8de4a77b620e28c617cc9cb18cd9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 10:09:27 2016 +0100

    Doxygen: SCardTransmit pioRecvPci is optional
    
    The parameter pioRecvPci of SCardTransmit() is optional and can be NULL.
    
    In fact this parameter is not used/modified by pcsc-lite or the libccid
    driver.
    
    Thanks to Maksim Ivanov for the bug report
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000536.html

 src/winscard_clnt.c | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit bfc6c15ec7b5941efaa48a1c1e5ff7d2cd8b0fa4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 10:02:02 2016 +0100

    Doxygen: pioSendPci argument of SCardTransmit is [in] only
    
    The argument pioSendPci of SCardTransmit() is not [in,out] but [in]
    only.
    
    Thanks to Maksim Ivanov for the bug report
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000536.html

 src/winscard_clnt.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 2a80f615fc5084838a9c299609fa468772fae71b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 09:54:12 2016 +0100

    Doxygen: SCardStatus() reader name arg is a C-string
    
    The szReaderName argument of the SCardStatus() function is a
    NUL-terminated C-string, not a multi string as documented.
    
    Thanks to Maksim Ivanov for the bug report
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000536.html

 src/testpcsc.c      | 16 ++++++++--------
 src/winscard.c      |  4 ++--
 src/winscard_clnt.c | 14 +++++++-------
 3 files changed, 17 insertions(+), 17 deletions(-)

commit a9dbb3c3ca1527228711f3e6c61fee15a1a80971
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 09:43:53 2016 +0100

    make definition of SCARD_SCOPE_GLOBAL public
    
    Move the definition of SCARD_SCOPE_GLOBAL from an internal header file
    to a public header file (pcsclite.h).
    SCARD_SCOPE_GLOBAL is now defined with the other SCARD_SCOPE_* values
    
    Thanks to Maksim Ivanov for the bug report
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000536.html

 src/PCSC/pcsclite.h.in | 1 +
 src/pcscd.h.in         | 2 --
 2 files changed, 1 insertion(+), 2 deletions(-)

commit f590a950283ca46cb0f3e8b3a640254c61f31ff2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 11 09:35:12 2016 +0100

    Doxygen: SCardGetStatusChange() may return SCARD_E_CANCELLED
    
    Thanks to Maksim Ivanov for the bug report
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20160307/000536.html

 src/winscard_clnt.c | 2 ++
 1 file changed, 2 insertions(+)

commit 56d59036d1c7be91fc480e861644e5d96cbdc377
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jan 29 18:02:20 2016 +0100

    pcscd --version: update copyright date
    
    I worked on the code from 2001 to 2015.

 src/pcscdaemon.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f4354e5b1293173fa3dc14aa28471193a29e36ea (tag: pcsc-1.8.15)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Dec 25 21:24:27 2015 +0100

    Release 1.8.15

 ChangeLog    | 8 ++++++++
 configure.ac | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit 5ad0431b9fe0c2a661e81ac8cc3ed52c436934e2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Dec 21 22:21:04 2015 +0100

    Add support of remove and/or customize PC/SC reader names
    
    To enable these two features you need to configure pcsc-lite with
    --enable-filter.
    
    Ignore some readers
    ===================
    If the environment variable PCSCLITE_FILTER_IGNORE_READER_NAMES is
    defined then it contains a list of patterns separated by the character
    ":".
    If a pattern is found in a PC/SC reader name then this reader is ignored
    and will not be reported by SCardListReaders() or any other PC/SC calls.
    
    Extend reader names
    ===================
    To differentiate the PC/SC reader names one idea is to use the host name
    of the system. If the IT department is doing correctly his job every
    laptop should have a different host name.
    
    If the environment variable PCSCLITE_FILTER_EXTEND_READER_NAMES is
    defined then it contains a string that will be added at the end of the
    PC/SC reader names.
    The computer host name is available in the variable $HOSTNAME. If you
    want to have a space character between the PC/SC reader name and host
    name you define PCSCLITE_FILTER_EXTEND_READER_NAMES as:
    " $HOSTNAME".
    
    See also
    http://ludovicrousseau.blogspot.fr/2015/12/remove-andor-customize-pcsc-reader-names.html

 configure.ac        | 12 +++++++++++
 src/readerfactory.c | 62 ++++++++++++++++++++++++++++++++++++++++++++++++++---
 2 files changed, 71 insertions(+), 3 deletions(-)

commit 415aa5316b6392df2a6d6ea1e4343663daf41f9b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Nov 18 17:04:50 2015 +0100

    hotplug_libudev.c: rename i into index
    
    To avoid reproducing the problem fixed in
    acb04f9ca3e20bde5290cd81f5091ca30b3e97db the variable i in renamed
    index. i is not a general/reusable variable.

 src/hotplug_libudev.c | 36 ++++++++++++++++++------------------
 1 file changed, 18 insertions(+), 18 deletions(-)

commit ed077d6cfa6a27221730e417bb2758bf78e11549
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Nov 18 16:57:44 2015 +0100

    hotplug_libudev.c: handle reader addition failure
    
    If RFAddReader() fails then the readerTracker[] entry must be cleaned.
    On exit pcscd will then not try to remove a non present reader.

 src/hotplug_libudev.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit acb04f9ca3e20bde5290cd81f5091ca30b3e97db
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Nov 18 16:53:08 2015 +0100

    hotplug_libudev.c: Fix asprintf(3) use
    
    The value returned by asprintf() is stored in i but i is also later used
    as the readerTracker[] index.
    
    The code was then completely broken. The code now uses a different
    variable.

 src/hotplug_libudev.c | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 285d7d631d4f63561e39fb6d768cb756ef5b9bd1
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Nov 6 09:27:14 2015 +0100

    Comments: Remove the $Id$ tag
    
    The $Id$ tag was used by subversion (svn) to indicate the file revision.
    This tag is now useless with git.

 DRIVERS                  | 2 --
 README                   | 3 ---
 doc/example/pcsc_demo.c  | 2 --
 src/PCSC/debuglog.h      | 2 --
 src/PCSC/ifdhandler.h    | 2 --
 src/PCSC/pcsclite.h.in   | 2 --
 src/PCSC/reader.h        | 2 --
 src/PCSC/winscard.h      | 2 --
 src/PCSC/wintypes.h      | 2 --
 src/README_INTERNALS.txt | 2 --
 src/atrhandler.c         | 2 --
 src/atrhandler.h         | 2 --
 src/configfile.h         | 2 --
 src/configfile.l         | 2 --
 src/debug.c              | 2 --
 src/debuglog.c           | 2 --
 src/dyn_generic.h        | 2 --
 src/dyn_hpux.c           | 2 --
 src/dyn_macosx.c         | 2 --
 src/dyn_unix.c           | 2 --
 src/error.c              | 2 --
 src/eventhandler.c       | 2 --
 src/eventhandler.h       | 2 --
 src/hotplug.h            | 2 --
 src/hotplug_generic.c    | 2 --
 src/hotplug_libudev.c    | 2 --
 src/hotplug_libusb.c     | 2 --
 src/hotplug_linux.c      | 2 --
 src/hotplug_macosx.c     | 2 --
 src/ifdwrapper.c         | 2 --
 src/ifdwrapper.h         | 2 --
 src/misc.h               | 2 --
 src/parser.h             | 2 --
 src/pcscd.h.in           | 2 --
 src/pcscdaemon.c         | 2 --
 src/powermgt_generic.c   | 2 --
 src/powermgt_generic.h   | 2 --
 src/prothandler.c        | 2 --
 src/prothandler.h        | 2 --
 src/readerfactory.c      | 2 --
 src/readerfactory.h      | 2 --
 src/spy/libpcscspy.c     | 2 --
 src/spy/pcsc-spy         | 2 --
 src/strlcpycat.h         | 2 --
 src/sys_generic.h        | 2 --
 src/sys_unix.c           | 2 --
 src/testpcsc.c           | 2 --
 src/tokenparser.l        | 2 --
 src/utils.c              | 2 --
 src/utils.h              | 2 --
 src/utils/formaticc.c    | 2 --
 src/utils/installifd.c   | 2 --
 src/winscard.c           | 2 --
 src/winscard_clnt.c      | 2 --
 src/winscard_msg.c       | 2 --
 src/winscard_msg.h       | 2 --
 src/winscard_msg_srv.c   | 2 --
 src/winscard_svc.c       | 2 --
 src/winscard_svc.h       | 2 --
 59 files changed, 119 deletions(-)

commit df879ec11c6c80dc70439ab433a055497000023d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Oct 20 17:47:58 2015 +0200

    pcscdaemon: update bug report list address
    
    The list <muscle@lists.musclecard.com> is dead since a few years now.
    Bugs should be reported to <pcsclite-muscle@lists.alioth.debian.org>
    (after you have subscribed to the list)

 src/pcscdaemon.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6f0dc9aabbdd533eac5bcdb2049519f6f1bcb607
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Oct 13 15:34:42 2015 +0200

    Doxygen: remove cross references
    
    The API documentation do not need to include:
    - functions calling the documented function
    - functions called internally by the documented function
    
    The Doxygen documentation is now shorter with no extra/useless
    information.

 doc/doxygen.conf.in | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0f90f0b9b85d38fdcac3aa9f4028d770f305978e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Oct 13 15:24:16 2015 +0200

    Doxygen: create a ErrorCode group
    
    Group all the PC/SC error codes in one group to make it easy to search
    for a particular error code.

 src/PCSC/pcsclite.h.in | 69 +++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 68 insertions(+), 1 deletion(-)

commit 1991c0be56d075fbb86357adf4e1590b225e1f9c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Oct 13 15:07:43 2015 +0200

    Doxygen: add a missing parameter documentation
    
    Fix doxygen warning:
    PCSC/src/winscard_clnt.c:3215: warning: The following parameters of SCardGetAndLockContext(SCARDCONTEXT hContext, int lock) are not documented:
      parameter 'lock'

 src/winscard_clnt.c | 1 +
 1 file changed, 1 insertion(+)

commit 433b6e36012eb589a2dc0eeca3b20d07514d3df6
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Aug 12 19:19:49 2015 +0200

    ChangeLog.git: include tags
    
    Use "--decorate=short" to include tags in the output like:
    commit 2891196bc817619c465920651d342a856d0551a3 (tag: pcsc-1.8.14)

 Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7eba88330cd4fad6b95cd6f49fe30df435d560cb
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 27 11:21:14 2015 +0200

    hotplug_libudev.c: fix compiler warnings
    
    hotplug_libudev.c: In function ‘HPAddDevice’:
    hotplug_libudev.c:443:2: warning: ignoring return value of ‘asprintf’, declared with attribute warn_unused_result [-Wunused-result]
      asprintf(&deviceName, "usb:%04x/%04x:libudev:%d:%s",
      ^
    hotplug_libudev.c:475:3: warning: ignoring return value of ‘asprintf’, declared with attribute warn_unused_result [-Wunused-result]
       asprintf(&result, "%s [%s]", fullname, sInterfaceName);
       ^
    hotplug_libudev.c:491:4: warning: ignoring return value of ‘asprintf’, declared with attribute warn_unused_result [-Wunused-result]
        asprintf(&result, "%s (%s)", fullname, sSerialNumber);
        ^
    
    Check the value returned by asprintf(3) and exit if it fails.

 src/hotplug_libudev.c | 22 +++++++++++++++++++---
 1 file changed, 19 insertions(+), 3 deletions(-)

commit 79410aac02a370d6d92106c015f01ec1491d31ac
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun Aug 9 10:21:49 2015 +0200

    pcscd: do not write to a closed file handle
    
    " In case of receiving a signal to terminate after init has been
    completed, at_exit() is called and tries to write to a closed pipe.
    
    This patch simply set pipe to -1 in order to invalidate it after
    closing.  Pipe value checks are already present in the code. "
    
    Signed-off-by: Herve Codina <Herve.CODINA@celad.com>

 src/pcscdaemon.c | 1 +
 1 file changed, 1 insertion(+)

commit 1f37c57feb81e8d263c696a845c4d054bdc11d0c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 7 15:04:12 2015 +0200

    tokenparser.l: config.h is a local file
    
    Use "config.h" instead of <config.h> so that the config.h is found in
    the local source directory.
    
    The problem was reported with HandlerTest that do not use -I. as
    compiler argument. The error was:
    tokenparser.l:45:20: fatal error: config.h: No such file or directory
     #include <config.h>
                        ^
    compilation terminated.

 src/tokenparser.l | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2891196bc817619c465920651d342a856d0551a3 (tag: pcsc-1.8.14)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Aug 5 12:55:15 2015 +0200

    Release 1.8.14

 ChangeLog    | 17 +++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 18 insertions(+), 1 deletion(-)

commit adacc765364284840762da3867e9cab7e3eb2b92
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Fri Jun 26 15:17:35 2015 +0200

    Initialize readerStates[].eventCounter to 0
    
    The field readerStates[].eventCounter was not initialized. It was not a
    real problem since the exact value is not used, only a value increment
    is used.
    
    The only problematic case was if readerStates[].eventCounter value is
    greater than 2^16. In that case the function SCardGetStatusChange() is
    no more able to detect card movement and would return immediatly.
    
    See also the previous patch.
    
    Thanks to Alan for the bug report.

 src/readerfactory.c | 1 +
 1 file changed, 1 insertion(+)

commit 75652c447c9d2b2f042fe01fbbcff40c79902e05
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Fri Jun 26 15:03:00 2015 +0200

    SCardGetStatusChange(): fix card movement bug
    
    The card movement counter eventCounter is a uint32_t and this value is
    also storded in the upper 16 bits of dwEventState.
    
    dwEventState should be copied in dwCurrentState by the application
    before the next call to SCardGetStatusChange().
    
    The upper 16 bits of dwCurrentState are then compared to eventCounter to
    detect a card movement.
    
    The alrogithm works fine if eventCounter can be stored on a 16-bits
    integer. The function SCardGetStatusChange() will return immediatly if
    eventCounter is greater than 2^16 even if no card movement happened.
    This is because eventCounter will always be different to the lowest
    16-bits of eventCounter stored in dwCurrentState.
    
    The patch resets eventCounter to 0 after 0xFFFF so its value can always
    be stored in a 16-bits integer.
    
    Thanks to Alan for the bug report
    https://alioth.debian.org/tracker/index.php?func=detail&aid=314929&group_id=30105&atid=410085
    [#314929] logic error in the implementation of the READER_STATE.eventCounter feature

 src/eventhandler.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 7a905f4bf5e917240c3529f0def63aafb40fe098
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Fri Jun 26 10:31:34 2015 +0200

    format display of SCARD_ATTR_VENDOR_IFD_VERSION
    
    Display the value of SCARD_ATTR_VENDOR_IFD_VERSION using the documented
    format: MM.mm.bbbb where MM = major version, mm = minor version, and
    bbbb = build number.

 src/testpcsc.c | 17 +++++++++++++++--
 1 file changed, 15 insertions(+), 2 deletions(-)

commit 459497acacf92c08183d47ea4fbc459476b3d4f4
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Fri Jun 26 10:17:50 2015 +0200

    Correctly display SCARD_ATTR_VENDOR_IFD_VERSION attribute
    
    The API documentation says about SCARD_ATTR_VENDOR_IFD_VERSION:
    Vendor-supplied interface device version (DWORD in the form 0xMMmmbbbb
    where MM = major version, mm = minor version, and bbbb = build number).
    
    But the CCID driver uses a fixed size of 4 bytes and type uint32_t to
    store the result.
    It works on 32-bits system but is wrong on some 64-bits systems (GNU Linux,
    not Mac OS X).
    
    On systems with sizeof(DWORD) = 64 the display of the value was
    incorrect.

 src/testpcsc.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit e607d167da9134a36987233ec4f3cf4a902bb2f5
Author: Ludovic Rousseau <lroussea@imacdelicretina.gemalto.com>
Date:   Thu Jun 25 14:04:35 2015 +0200

    FEATURE_CCID_ESC_COMMAND_Gemalto_features.py: add LANGIDs pdf URL
    
    Add USB_LANGIDs PDF URL so I do not have to search it again for the next
    LANGID I am looking for.

 UnitaryTests/FEATURE_CCID_ESC_COMMAND_Gemalto_features.py | 1 +
 1 file changed, 1 insertion(+)

commit 832c0bf87f157736e78cdfcbf733a67e74515869
Author: Ludovic Rousseau <lroussea@imacdelicretina.gemalto.com>
Date:   Thu Jun 25 14:02:35 2015 +0200

    FEATURE_CCID_ESC_COMMAND_Gemalto_features.py: add "Spanish"
    
    Add the "Spanish (Traditional Sort)" in USBLangID dictionnary.

 UnitaryTests/FEATURE_CCID_ESC_COMMAND_Gemalto_features.py | 1 +
 1 file changed, 1 insertion(+)

commit 85d8dea93679c98b9673e71dd0d1b9cf793b6db0
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Tue Jun 23 14:50:22 2015 +0200

    Threading: lock the card context in a safe way
    
    Functions working on hCard now acquire the context lock while the
    global thread lock is held.
    
    This will avoid the context to be released between the context retrieval
    and context lock. The code was ugly with a new call to
    SCardGetContextAndChannelFromHandle() to check that the context was
    still valid.
    
    This patch similar than the one in
    9681246742b812ba1b8acbe8892d8aa755215059 for hContext.
    
    Thanks to Luc Mazardo for the bug report.
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20150608/000395.html

 src/winscard_clnt.c | 187 ++++++++--------------------------------------------
 1 file changed, 27 insertions(+), 160 deletions(-)

commit 9681246742b812ba1b8acbe8892d8aa755215059
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Tue Jun 23 09:21:25 2015 +0200

    Threading: lock the PC/SC context in a safe way
    
    Functions working on hContext now acquire the context lock while the
    global thread lock is held.
    
    This will avoid the context to be released between the context retrieval
    and context lock. The code was ugly with a new call to
    SCardGetContext()to check that the context was still valid.
    
    Thanks to Luc Mazardo for the bug report.
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20150608/000395.html

 src/winscard_clnt.c | 81 ++++++++++-------------------------------------------
 1 file changed, 15 insertions(+), 66 deletions(-)

commit 7a023f9c8a769f9d1ae6dcdc80e8ced381908a0d
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Tue Jun 23 13:54:25 2015 +0200

    Add new API traces calls
    
    Add API_TRACE_IN/API_TRACE_OUT for functions:
    - SCardReconnect()
    - SCardBeginTransaction()
    - SCardEndTransaction()

 src/winscard_clnt.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit c7f396f23923a07b4055500d45ba04d8bcf9ddab
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Mon Jun 15 14:25:18 2015 +0200

    Doxygen: fix typo
    
    And make it explicit that wa are talking about PC/SC transactions.

 src/winscard_clnt.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit fb38b061843212b3dd5908f344edd2f3f397dce5
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Tue Jun 9 16:05:09 2015 +0200

    Doxygen: SCardReconnect() do not release locks
    
    Document a new difference between pcsc-lite and Windows winscard.
    
    Any transaction help by the process is still valid after
    SCardReconnect() returned. On Windows the transactions are released and
    a new call to SCardBeginTransaction() must be done.

 src/winscard_clnt.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 040a4fa25e2896e80d341c5e1a822d1d04c57e55
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Thu Jun 4 11:11:03 2015 +0200

    Doxygen: fix SCardEndTransaction() documentation
    
    The disposition IS used and the dwDisposition parameter HAS an effect.
    
    The mis-documentation was present since the Doxygen introduction in
    2005.
    https://anonscm.debian.org/cgit/pcsclite/PCSC.git/diff/src/winscard_clnt.c?id=f53ee3d89881da56e5b90d7cedb218dcc5024237

 src/winscard_clnt.c | 1 -
 1 file changed, 1 deletion(-)

commit 7b11b1f2cf201ad403db02723edb68a192aefde2
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Tue Jun 2 11:37:19 2015 +0200

    SCardReconnect.py: Fix typo in comment

 UnitaryTests/SCardReconnect.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8eb9ea1b354b050f997d003cf3b0c5b56f29f9f7
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Fri May 29 10:01:43 2015 +0200

    SCardTransmit() may return SCARD_E_INSUFFICIENT_BUFFER
    
    SCardTransmit() now correctly returns SCARD_E_INSUFFICIENT_BUFFER when
    pcbRecvLength is not big enough to receive the card response.
    
    The APDU is succesfully exchanged with the card but the card response is
    lost since the client application buffer is not large enough to receive
    it.
    
    Before this patch an error was reported in the CCID driver and the
    application got a SCARD_E_NOT_TRANSACTED error instead.
    
    Now the expected size is available in pcbRecvLength for the application
    to adapt its buffer size and, possibly, recall SCardTransmit().
    
    Thanks to Mironenko for the bug report
    https://github.com/LudovicRousseau/CCID/pull/5

 UnitaryTests/BufferOverflow2.c | 86 ++++++++++++++++++++++++++++++++++++++++++
 UnitaryTests/Makefile          |  1 +
 src/winscard_clnt.c            |  2 +-
 src/winscard_svc.c             |  8 +++-
 4 files changed, 95 insertions(+), 2 deletions(-)

commit e2752b7b26b0fc6cbee5f66be501396245cefee1
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri May 15 17:59:08 2015 +0200

    Use correct prototype for pcsc_stringify_error()
    
    If NO_LOG is defined the code failed to build on Mac OS X:
    error.c:53:16: error: conflicting types for 'pcsc_stringify_error'
    PCSC_API char* pcsc_stringify_error(const long pcscError)
                   ^
    ../src/PCSC/pcsclite.h:237:7: note: previous declaration is here
    char *pcsc_stringify_error(const LONG);
          ^
    1 error generated.
    
    The prototype used in the case of NO_LOG was not the same as in the normal
    case: "long" instead of "LONG".
    
    Thanks to Frank Morgner for the bug report.
    https://github.com/LudovicRousseau/PCSC/pull/1

 src/error.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7b22153844b6246e79c1fd12220c867663e6cb4b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat May 2 16:12:10 2015 +0200

    Generate a ChangeLog using git instead of svn
    
    The repository moved from SVN to GIT. So the ChangeLog is now called
    ChangeLog.git and is generated using git.

 Makefile.am | 18 ++++--------------
 1 file changed, 4 insertions(+), 14 deletions(-)

commit ef0bec5ddd3ecdd758b28ce4d2a13e5a6b01e969
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Mar 23 08:32:50 2015 +0000

    Add Language Identifiers for Czech and Slovak
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7103 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/FEATURE_CCID_ESC_COMMAND_Gemalto_features.py | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 899f91be9619910e028c3218d3ac87a6757dc657
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 24 15:12:10 2015 +0000

    Check PCSCv2_PART10_PROPERTY_wIdVendor is returned
    
    Some drivers do not return a value for PCSCv2_PART10_PROPERTY_wIdVendor.
    We must check the value exist before using it.
    
    Use "key in dict" instead of try/except to know a key is defined.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7096 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/control_get_firmware.py | 29 +++++++++++++++++------------
 1 file changed, 17 insertions(+), 12 deletions(-)

commit e4c0bcbe8d1e78f5ff4e830ca3e718203992cef4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jan 5 15:55:51 2015 +0000

    Do not call SCardCheckDaemonAvailability() twice
    
    Doing a second call to SCardCheckDaemonAvailability() if the first one
    failed is no more needed since revision 5384.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7078 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 4 ----
 1 file changed, 4 deletions(-)

commit 89298d5e4ee195f03d2763146c8345175ea03495
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jan 5 15:53:51 2015 +0000

    Update Doxygen doc for SCardCheckDaemonAvailability()
    
    The function do not return SCARD_E_INVALID_HANDLE since revision 5384.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7077 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 4 ----
 1 file changed, 4 deletions(-)

commit 8964779f0c5be833c90bbba341df3c39780c88f9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 20:30:19 2014 +0000

    Unlist strlcat and strlcpy related files
    
    No need to ignore ignore strlcat and strlcpy object files.
    The source files are no more used.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7076 0ce88b0d-b2fd-0310-8134-9614164e65ea

 .gitignore | 4 ----
 1 file changed, 4 deletions(-)

commit afc3f76e068628d8aafb2f153ef80d6fe73b387b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 20:27:34 2014 +0000

    Unlist strlcat.c and strlcpy.c
    
    These files are no more used by pcscd and libpcsclite.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7075 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/README_INTERNALS.txt | 4 ----
 1 file changed, 4 deletions(-)

commit ff0dad4bc05495291abbed6bfdedeeba4f6530b3
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 20:25:22 2014 +0000

    Remove src/strlcat.c and src/strlcpy.c license
    
    Theses files are no more included in pcsc-lite
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7074 0ce88b0d-b2fd-0310-8134-9614164e65ea

 COPYING | 16 ----------------
 1 file changed, 16 deletions(-)

commit 5c6eb3ab572d069ad99c0c5722ea5d09171167fe
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 20:22:57 2014 +0000

    Do not check for strlcpy strlcat functions
    
    strlcpy and strlcat are no more used in pcsc-lite.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7073 0ce88b0d-b2fd-0310-8134-9614164e65ea

 configure.ac | 3 ---
 1 file changed, 3 deletions(-)

commit c1c4293f59d8bbfa928ff1bbacfbbe5cf32a8dbd
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 20:21:09 2014 +0000

    Remove strlcpy.c and strlcpycat.h
    
    pcsc-lite do not use strlcpy(3) any more.
    We can remove these files from the distribution.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7072 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/Makefile.am | 3 ---
 1 file changed, 3 deletions(-)

commit d6a9b4b154e1e765ac3775e0f63d78982ea6aa48
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 19:25:40 2014 +0000

    Do not use strlcpy(3)
    
    Remove the dependency.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7071 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard.c | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 8590b83a2a5e9059f7234d27113da3cefec7c8d8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 18:00:29 2014 +0000

    Do not use strlcpy(3)
    
    Remove the dependency.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7070 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_msg.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit dc8f29f02b9b29cd6f855440f5ff4a7b94996d07
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 17:57:54 2014 +0000

    Do not use strlcpy(3)
    
    Remove the dependency.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7069 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 14d3cf8b8dc849c12061d52f55501899f71112bc
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 17:55:09 2014 +0000

    Do not use strlcpy(3)
    
    Remove the dependency.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7068 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/tokenparser.l | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 0fec8cdaf00251bdf7b223ee35ba67f068243b51
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 17:50:26 2014 +0000

    Do not use strlcpy(3)
    
    Remove the dependency.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7067 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit faf58b42712a4fb89861bb11f137a5a6be60d7a2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 17:43:42 2014 +0000

    Do not use strlcpy(3)
    
    Remove the dependency.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7066 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/error.c | 83 +++++++++++++++++++++++++++++++++----------------------------
 1 file changed, 45 insertions(+), 38 deletions(-)

commit e7bd8d111c2d554b4a619f98eed976d772c6d83b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 17:33:21 2014 +0000

    Remove extra #include
    
    #include "strlcpycat.h" is not needed here. No strl* function is called
    in this source code.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7065 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/eventhandler.c    | 1 -
 src/hotplug_libudev.c | 1 -
 2 files changed, 2 deletions(-)

commit dd75c7f6d8d978d784992fe1069716ac950cbaae
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 17:29:59 2014 +0000

    Do not use strlcpy(3)
    
    Remove the dependency.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7064 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/debuglog.c | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit 7a50286d5b5c79516062b779574f94d1b799c3a9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 17:13:19 2014 +0000

    Remove extra #include
    
    #include "strlcpycat.h" is not needed here. No strl* function is called
    in this source code.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7062 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/debug.c | 1 -
 1 file changed, 1 deletion(-)

commit 8db475dd95e27a122922ccd05c10c0b91b1d2745
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 12:38:35 2014 +0000

    Initialize fullname just in case
    
    strdup(3) and asprintf(3) may fail. This case is not managed by the code
    but at least a NULL value should make the code crash.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7061 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1953142389773d29530b21afd2eb7d39f0cb35ef
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 12:36:55 2014 +0000

    Use GNU asprintf(3) to generate the deviceName
    
    The deviceName is no more limited to MAX_DEVICENAME characters.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7060 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit 997026a5679e5cb7b96906f388cdc2fdd2a283af
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 12:22:13 2014 +0000

    Remove strlcat(3) copy
    
    Since revision 7058 strlcat(3) is no more used in pcsc-lite.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7059 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/Makefile.am |  2 --
 src/strlcat.c   | 63 ---------------------------------------------------------
 2 files changed, 65 deletions(-)

commit e059002daef85325a6b6ae810d32e41848b2e70e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 12:19:43 2014 +0000

    Use asprintf(3) (from GNU) instead of strlcat(3)
    
    http://lwn.net/Articles/612627/
    " strlcpy() in glibc
    
    Posted Sep 19, 2014 23:34 UTC (Fri) by Koromix (subscriber, #71455)
    In reply to: strlcpy() in glibc by epa
    Parent article: Adding strlcpy() to glibc
    
    None that I know of. When I manipulate dynamic raw C strings I go for
    one of these:
    - asprintf is great, you can't abuse it
    - malloc + a suite of stpcpy
    - strdup (with in-place characters substitutions on the copy if needed,
      such as fixing slashes in paths)
    
    I almost never use strcat because stpcpy is more efficient.
    
    This is enough when your code does little string handling (some
    identifiers, a few paths here and there). Beyond that, it's inefficient
    and insecure and you better use another language (C++) or at the very
    least a higher-level string handling code/library.
    
    Note that for cross-platform code you may need to provide fallback
    implementations of asprintf and stpcpy/stpncpy. "
    
    With this patch we can remove our own copy (from OpenBSD) of strlcat(3).
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7058 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 27 +++++++++++++++++++--------
 1 file changed, 19 insertions(+), 8 deletions(-)

commit d17bd2a9abe6b573b65b03c31d016b20349c51e1
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Dec 31 11:49:17 2014 +0000

    Simplify code of DebugLogSetCategory()
    
    Remove the use of strlcat(3)
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7057 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/debuglog.c | 10 +---------
 1 file changed, 1 insertion(+), 9 deletions(-)

commit a634851704d6a7e2fe6e828b4de17623c3198d66
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Dec 20 15:13:49 2014 +0000

    --hotplug is only for non-USB readers
    
    For now --hotplug is only usable when hotplug_libusb.c is used.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7055 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 772edc852c912670577ddbdd4c565731ab5334fe
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Dec 11 14:51:17 2014 +0000

    Change the default PolKit policy
    
    Use no:no:yes instead of auth_admin:auth_admin:yes as suggested by
    Stanislav Brabec
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20141208/000267.html
    
    This change is related to the PolKit change in revision 7050.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7051 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/org.debian.pcsc-lite.policy | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 81c67cbe5b425bc398d9983c77a6e13e9f664a68
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Dec 4 09:11:26 2014 +0000

    Allow to use pcscd in a remote session
    
    " Current implementation of polkit support disallows auth by
    challenge/response, effectively turning "auth_admin" present in the
    default policy to "no".
    
    Attached patch makes possible to use polkit challenge/response agent to
    be authorized.
    
    It makes possible to use pcscd in a remote session (providing admin
    password to the agent).
    
    Possible problem: If the authorization agent is present and active,
    polkit_authority_check_authorization_sync() could take a long time (the
    time of users' response). If the next request comes in the same time, it
    is postponed until the previous one is handled. (Actions done by root
    are not postponed.) "
    
    Thanks to Stanislav Brabec for the patch
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20141201/000247.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7050 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/auth.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 235b1cc8c67f28ecc3687f79446d6d19d5acc491
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Dec 4 09:09:40 2014 +0000

    Fix typos in comments
    
    Thanks to David Woodhouse for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7049 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cfe1af31e823662e7c073b6439aee5f99eeabb34
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Nov 18 08:16:54 2014 +0000

    Fix typos in comments
    
    Thanks to David Woodhouse for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7043 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 798639e22aeee39f0a35dd7bc9bac0df6e9794c5
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Nov 14 09:08:41 2014 +0000

    Specify the character set used for reader names
    
    - PC/SC reader names are using UTF-8.
    
    - Info.plist reader names must use the ASCII character set.
      Or even a subset of ASCII.
    
    Since ASCII is a subset of UTF-8 we are fine. Reader names may become
    full UTF-8 in a later version of pcsc-lite.
    
    Thanks to David Woodhouse for the idea
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20141110/000243.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7041 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/PCSC/ifdhandler.h | 2 ++
 src/winscard_clnt.c   | 3 +++
 2 files changed, 5 insertions(+)

commit aa3058d6f848c8c5bb446713b17f0c48a6713f70 (tag: pcsc-1.8.13)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Nov 7 12:18:04 2014 +0000

    Release 1.8.13
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7036 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 9 +++++++++
 configure.ac | 2 +-
 2 files changed, 10 insertions(+), 1 deletion(-)

commit 89776012839e50e8df8f974a62913d99f41056a5
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Nov 7 12:13:40 2014 +0000

    Fix compiler warnings
    
    auth.c: In function ‘IsClientAuthorized’:
    auth.c:151:33: warning: unused parameter ‘socket’ [-Wunused-parameter]
     unsigned IsClientAuthorized(int socket, const char* action, const char* reader)
                                     ^
    auth.c:151:53: warning: unused parameter ‘action’ [-Wunused-parameter]
     unsigned IsClientAuthorized(int socket, const char* action, const char* reader)
                                                         ^
    auth.c:151:73: warning: unused parameter ‘reader’ [-Wunused-parameter]
     unsigned IsClientAuthorized(int socket, const char* action, const char* reader)
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7035 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/auth.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 11e7cf2bb4211f81b6f5569c8c96f3ed9885326d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Nov 7 12:10:52 2014 +0000

    Fix compiler warning
    
    auth.c:150:10: warning: no previous prototype for ‘IsClientAuthorized’ [-Wmissing-prototypes]
     unsigned IsClientAuthorized(int socket, const char* action, const char* reader)
              ^
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7034 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/Makefile.am | 2 +-
 src/auth.c      | 1 +
 2 files changed, 2 insertions(+), 1 deletion(-)

commit b9c5b8f1d01fa37ffa7b329619f22fb8f9c6ab45
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Nov 7 10:04:52 2014 +0000

    Fix again libudev hotplug
    
    The change in revision 7028 broke the fix introduced in revision 6951.
    
    Thanks again to Stefani Seibold for the new fix
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20141103/000226.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7033 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 55 +++++++++++++++++++++++++++------------------------
 1 file changed, 29 insertions(+), 26 deletions(-)

commit 641de01d6abef09b3db6af8361a0982f2c3aad1d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Nov 6 14:57:11 2014 +0000

    Do not access pipefd[] after use
    
    It is NOT safe to pass to a thread a pointer to a locally allocated array.
    When the caller exits the scope of the array then the memory is reused.
    So any reference to the array becomes illegal memory access.
    
    Thanks to Maximilian Stein for the patch
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20141103/000218.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7029 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libusb.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 5764a393663791b83134a1ca60b682a7df3d7acb
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Nov 6 14:24:02 2014 +0000

    Scan the USB bus at least once before accepting client connections
    
    The bug was introduced in pcsc-lite version 1.8.12 with revision 6951.
    
    Closes Alioth bug [#314869] pcscd: Socket activation not working on first try
    https://alioth.debian.org/tracker/index.php?func=detail&aid=314869&group_id=30105&atid=410085
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7028 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit a82a908265888fdaff098f63e74b9006c470bfb7
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Nov 6 13:56:10 2014 +0000

    Use ldconfig(8) to find the directory containing libpcsclite.so.1
    
    On a Debian system (using multiarch) the directory is no more /usr/lib
    but /usr/lib/x86_64-linux-gnu on a 64-bits Intel system.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7027 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/install_spy.sh   | 14 +++++++++++++-
 src/spy/uninstall_spy.sh | 14 +++++++++++++-
 2 files changed, 26 insertions(+), 2 deletions(-)

commit d067ec8ed7f13eddd5a066998e928474a9e84b79
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Nov 6 09:08:07 2014 +0000

    Do not log an error when pcscd is started by systemd
    
    If pcscd is started by systemd then /var/run/pcscd/pcscd.comm exists but
    /var/run/pcscd/pcscd.pid do not exists yet. So an error was logged:
    pcscd[2536]: 00000000 utils.c:87:GetDaemonPid() Can't open /var/run/pcscd/pcscd.pid: No such file or directory
    
    Now /var/run/pcscd/pcscd.pid is used only if pcscd is NOT started by
    systemd.
    
    Close Alioth bug [#314862] Should not log an error Can't open /var/run/pcscd/pcscd.pid when started by systemd
    https://alioth.debian.org/tracker/index.php?func=detail&aid=314862&group_id=30105&atid=410085
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7026 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 40bc07dd4c6092b431b0673ca619e6390b87ed12
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Oct 22 15:06:26 2014 +0000

    Use \- for -
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7016 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 822ca7b877f2fde198211247ef5494b2dfd08f64
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Oct 22 15:04:20 2014 +0000

    Add documentation for --reader-name-no-interface
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7015 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 3 +++
 1 file changed, 3 insertions(+)

commit fef803a7aa60d0bba8c9e4fdb4bdfffaca4e464b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Oct 22 15:03:18 2014 +0000

    dd documentation for --reader-name-no-serial
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7014 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 3 +++
 1 file changed, 3 insertions(+)

commit e78be691c5285a3a99d45a6438195ad0bdca6049
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Oct 22 15:01:17 2014 +0000

    Add documentation for --auto-exit
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7013 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 4 ++++
 1 file changed, 4 insertions(+)

commit 8ed4b289005e87c0cdece2a563d55a67f0282db8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Oct 2 09:48:08 2014 +0000

    Add licenses for files from other projects
    
    src/auth.c and src/auth.h are from Red Hat
    src/sd-daemon.c and src/sd-daemon.h are from systemd
    src/simclist.c and src/simclist.h are from SimCList
    src/strlcpy.3, src/strlcat.c and src/strlcpy.c are from OpenBSD
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7007 0ce88b0d-b2fd-0310-8134-9614164e65ea

 COPYING | 88 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 88 insertions(+)

commit d11260d2a4e73999faebd20d725734ec5464e4db
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Oct 2 09:41:13 2014 +0000

    Add missing 3-clause BSD license
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7006 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscd.h.in | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit 8a78f90db82f85ad78ab259ce880cf17ae559b60
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Oct 2 09:36:15 2014 +0000

    Add GNU GPL v3 license header
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7005 0ce88b0d-b2fd-0310-8134-9614164e65ea

 COPYING | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 1e3864854bab68937cc673f108d81451f53dd370
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Oct 2 09:26:36 2014 +0000

    Make the license more 3-clause BSD like
    
    The line "Changes to this license can be made only by the copyright
    author with explicit written consent." was present in the pcsc-lite
    license from the origin of the project (at least since the initial
    version of COPYING in the VCS in March 2002).
    
    This line is not present in the 3-clause BSD license
    http://en.wikipedia.org/wiki/BSD_licenses
    
    The change has been approved by David Corcoran, initial author of
    pcsc-lite.
    
    The change was requested by Oracle about the headers files winscard.h
    and pcsclite.h " To include in OpenJDK, Oracle needs the right to
    relicense under other terms."
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7004 0ce88b0d-b2fd-0310-8134-9614164e65ea

 COPYING                                    | 3 ---
 UnitaryTests/SCardBlockingBehaviourTest.py | 3 ---
 UnitaryTests/SCardExclusiveBehaviour.py    | 3 ---
 src/PCSC/debuglog.h                        | 3 ---
 src/PCSC/ifdhandler.h                      | 3 ---
 src/PCSC/pcsclite.h.in                     | 3 ---
 src/PCSC/reader.h                          | 3 ---
 src/PCSC/winscard.h                        | 3 ---
 src/PCSC/wintypes.h                        | 3 ---
 src/atrhandler.c                           | 3 ---
 src/atrhandler.h                           | 3 ---
 src/configfile.h                           | 3 ---
 src/configfile.l                           | 3 ---
 src/debug.c                                | 3 ---
 src/debuglog.c                             | 3 ---
 src/dyn_generic.h                          | 3 ---
 src/dyn_hpux.c                             | 3 ---
 src/dyn_macosx.c                           | 3 ---
 src/dyn_unix.c                             | 3 ---
 src/error.c                                | 3 ---
 src/eventhandler.c                         | 3 ---
 src/eventhandler.h                         | 3 ---
 src/hotplug.h                              | 3 ---
 src/hotplug_generic.c                      | 3 ---
 src/hotplug_libudev.c                      | 3 ---
 src/hotplug_libusb.c                       | 3 ---
 src/hotplug_linux.c                        | 3 ---
 src/hotplug_macosx.c                       | 3 ---
 src/ifdwrapper.c                           | 3 ---
 src/ifdwrapper.h                           | 3 ---
 src/lassert.h                              | 3 ---
 src/misc.h                                 | 3 ---
 src/parser.h                               | 3 ---
 src/pcsc-wirecheck-gen.c                   | 3 ---
 src/pcscdaemon.c                           | 3 ---
 src/powermgt_generic.c                     | 3 ---
 src/powermgt_generic.h                     | 3 ---
 src/prothandler.c                          | 3 ---
 src/prothandler.h                          | 3 ---
 src/readerfactory.c                        | 3 ---
 src/readerfactory.h                        | 3 ---
 src/strlcpycat.h                           | 3 ---
 src/sys_generic.h                          | 3 ---
 src/sys_unix.c                             | 3 ---
 src/testpcsc.c                             | 3 ---
 src/tokenparser.l                          | 3 ---
 src/utils.c                                | 3 ---
 src/utils.h                                | 3 ---
 src/utils/formaticc.c                      | 3 ---
 src/utils/installifd.c                     | 3 ---
 src/winscard.c                             | 3 ---
 src/winscard_clnt.c                        | 3 ---
 src/winscard_msg.c                         | 3 ---
 src/winscard_msg.h                         | 3 ---
 src/winscard_msg_srv.c                     | 3 ---
 src/winscard_svc.c                         | 3 ---
 src/winscard_svc.h                         | 3 ---
 57 files changed, 171 deletions(-)

commit fb079dda961491c85a97502c6bd27c2d0be6d909
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 24 13:08:09 2014 +0000

    The GPL license has been moved to the root directory
    
    And version is now 3.0 instead of 2.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@7001 0ce88b0d-b2fd-0310-8134-9614164e65ea

 Makefile.am             | 1 +
 doc/example/Makefile.am | 3 ---
 2 files changed, 1 insertion(+), 3 deletions(-)

commit 0842328655f97d7b00be25619df407b8d1589f51 (tag: pcsc-1.8.12)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 24 13:03:57 2014 +0000

    Release 1.8.12
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6999 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 8 ++++++++
 configure.ac | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit 3e52017868f900ff5c1b932913deb325b8c8dcfa
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Sep 19 16:10:02 2014 +0000

    Fix pyflakes warning
    
    SCardConnect_DIRECT2.py:36: 'sys' imported but unused
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6997 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/SCardConnect_DIRECT2.py | 1 -
 1 file changed, 1 deletion(-)

commit cd50343d6b43e8a1d82e06e200d695f1ad6b2162
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Sep 19 16:09:23 2014 +0000

    Fix pyflakes warning
    
    SCardGetAttrib.py:25: 'sys' imported but unused
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6996 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/SCardGetAttrib.py | 1 -
 1 file changed, 1 deletion(-)

commit fa5115b76783bb2ea5475b9edc2eb744df184472
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Sep 19 16:06:13 2014 +0000

    Fix pyflakes warning
    
    SCardBlockingBehaviourTest.py:234: local variable 'hresult' is assigned to but never used
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6995 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/SCardBlockingBehaviourTest.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 788f0761d2e41c47b3ca68339e68f73689e5deff
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Sep 19 16:04:48 2014 +0000

    Fix pyflakes warning
    
    SCardBlockingBehaviourTest.py:249: local variable 'hresult' is assigned to but never useX
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6994 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/SCardBlockingBehaviourTest.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f439cbd18e7784bc2a023790aca3ad97c3699f39
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Sep 19 16:02:09 2014 +0000

    Fix stupid bug
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6993 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/control_get_firmware.py | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 737394bf662beff58ec5cdcdc519506e9bd147d1
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 17 13:16:12 2014 +0000

    Do not use FreeSans.ttf anymore
    
    Warning: doxygen no longer ships with the FreeSans font.
    You may want to clear or change DOT_FONTNAME.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6991 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/doxygen.conf.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 02bee5cc2b70403a8f0d70ee321e15bad5f425f8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 17 13:12:35 2014 +0000

    Update from Doxygen 1.8.1.1 to 1.8.7
    
    Used "doxygen -u"
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6990 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/doxygen.conf.in | 2354 +++++++++++++++++++++++++++++++--------------------
 1 file changed, 1437 insertions(+), 917 deletions(-)

commit 74e384f77ed79301b341b91b2b17082cdc69acf2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 17 13:01:38 2014 +0000

    Fix Doxygen for SCardGetStatusChange()
    
    A value of 0 for dwTimeout is not equivalent of INFINITE but of 0 ms.
    
    Thanks to helpcrypto for the bug report.
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20140915/000141.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6989 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit da9dac160226d51a3d9d60add7e141fd4fc56ba4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Sep 17 07:54:37 2014 +0000

    Update driver web page
    
    http://www.musclecard.com/drivers.html is no more available. A copy is
    available at http://pcsclite.alioth.debian.org/musclecard.com/drivers.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6987 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 5d3e6b5f81259dc3d488ded0ab59d09ba05e9ad2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Sep 15 08:04:47 2014 +0000

    Use <config.h> instead of "config.h"
    
    https://www.gnu.org/software/autoconf/manual/autoconf-2.65/html_node/Configuration-Headers.html
      With the appropriate -I option, you can use #include <config.h>.
      Actually, it's a good habit to use it, because in the rare case when
      the source directory contains another config.h, the build directory
      should be searched first.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6986 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/strlcpy.c     | 2 +-
 src/tokenparser.l | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 02ff548c5dd87978e2529b5ab1c10a7405268248
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Sep 15 08:03:41 2014 +0000

    Fix error reported by flake8
    
    pcsc-spy:795:20: E711 comparison to None should be 'if cond is None:'
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6985 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/pcsc-spy | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bd3f60de8346a4836aa2412b7758ff04e621ec52
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 9 09:21:27 2014 +0000

    Unitary Test for change in revision 6978
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6979 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/Makefile |  3 ++-
 UnitaryTests/exec.c   | 55 +++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 57 insertions(+), 1 deletion(-)

commit bdd9aa76acfe277b978ccd19e5751f958749c238
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 9 09:18:06 2014 +0000

    Create the libpcsclite/pcscd socket with the SOCK_CLOEXEC flag
    
    The communication socket between libpcsclite and pcscd is created with
    the SOCK_CLOEXEC flag added so the socket is automatically closed when
    the process (or its childs) calls exec().
    
    The problem happens when an application does exec() without cleaning its
    use of libpcsclite using SCardReleaseContext(). I could not reproduce a
    real problem but it has been reported on the field with a closed source
    application.
    
    Thanks to Stefani Seibold for the bug report and patch.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6978 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_msg.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 23192fddfcbba1b31f8ffc95f2d1366dc7a81d29
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Sep 1 14:52:42 2014 +0000

    Remove extra spaces at end of lines
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6965 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/PCSC/debuglog.h    |  6 +++---
 src/PCSC/ifdhandler.h  | 16 ++++++++--------
 src/PCSC/pcsclite.h.in |  4 ++--
 src/auth.h             |  2 +-
 4 files changed, 14 insertions(+), 14 deletions(-)

commit a9bf717855688d15b286005f51fe48dfb85c8169
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 7 12:59:33 2014 +0000

    Udev is a global variable
    
    Rename udev as Udev to make it more explicit it is a global variable.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6953 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 1b28f8cf724b14459745fde3b6817d910ed2886a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 7 12:57:09 2014 +0000

    Add a missing break;
    
    I removed the line when testing the code. This bug is mine, not
    Stefani's
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6952 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 1 +
 1 file changed, 1 insertion(+)

commit 4971882325b775afff7071867355342a0d1744f0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 7 12:54:03 2014 +0000

    Revamp libudev hotplug
    
    " Hi,
    
    this is a complete revamp of src/hotplug_libudev.c hotplug handling.
    This patch fix a lot of race conditions and make the code a bit cleaner.
    
    The following benefits will be achieved:
    
    - udev events will be handled seperatly, a "add" event will only add a
    device and a "remove" will now only remove the device. So the whole
    bookkeeping is now done by the udev daemon, there is no more need to
    track the state of the device. Also it fix a race where udev had yet not
    finished the plug event and the device is not full accessible.
    
    - fix the race gap between the coldplug scan and the activating of the
    monitoring hotplug events. Now the monitoring will be first activated
    and the the coldplug scan will be done. So there is a small change that
    a device will be added during the coldplug scan. For this the
    HPAddDevice() function needs to check for duplicate adds of a device.
    But that is common design of libudev usage.
    
    - No more mutex needed since there is no more concurrency, because the
    coldplug scan will be no done inside the thread.
    
    - Do not start the thread detached since there is no way to do a
    synchronized stop of the thread. The HPStopHotPluggables() will now wait
    until the thread is gone. So it is save to free memory of structures
    since no one is access them.
    
    - Remove the cooperative thread cancellation by AraKiriHotPlug. Despite
    the non political correctness it will not work as expected, because the
    select() system call will block infinitly. Using the pthread_cancel()
    mechanism will do a better and safer job.
    
    - Add signal safety to the select() system call. A EINTR should not lead
    in a termination of the thread.
    
    - Fix a typo: pluggble > plugable
    
    - Make less error prone for unexpected libudev return values. Check all
    return values of udev_...() functions against NULL.
    
    - Fix resource leak in hotplug thread. The udev_device_unref() was never
    called on event "remove".
    
    - Cleanup HPStopHotPluggables() function, which release now all
    allocated resources, including udev. It also will not crash when in
    HPRegisterForHotplugEvents() was not able to acquire resources.
    
    - Replace the prehistoric select() by poll(), which is faster and
    consumes less memory.
    
    Changlog:
    
    V1 4-Aug-2014
            first release
    V2 5-Aug-2014
            Fix coding style. Optimize HPRemoveDevice()
            Cleanup HPStopHotPluggables()
            Fix a resource leak not calling udev_device_unref() in case of "add" or "remove" event.
    V3 5-Aug-2014
            Fix resource leak in HPStopHotPluggables(), release udev
            Fix error handling in HPRegisterForHotplugEvents() and HPStopHotPluggables()
            Revert unneeded RFRemoveReader() in HPRegisterForHotplugEvents()
    
    - Stefani
    
    Signed-off-by: Stefani Seibold <stefani at seibold.net> "
    
    Thanks to Stefani Seibold for the patch
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20140804/000093.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6951 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 358 ++++++++++++++++++++++++++------------------------
 1 file changed, 183 insertions(+), 175 deletions(-)

commit 254b9e343522a385ad2af636dfc1956ec67f9cac
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Aug 6 21:01:43 2014 +0000

    Adjust the thread stack size
    
    The size of 4 MB is not needed and too big (see revision 6948).
    By default the thread stack size is:
    - 8 MB on Debian GNU/Linux
    - 256 KB on Mac OS X 10.9
    - 80 KB on musl, but it is not enough for pcsc-lite
    
    256 KB (like on Mac OS X 10.9) is enough for musl.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6950 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit bfc6ce17dfb947da3b32f328e7d7851d96861106
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Aug 6 14:26:41 2014 +0000

    Factorize error code
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6949 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils.c | 20 +++++---------------
 1 file changed, 5 insertions(+), 15 deletions(-)

commit cd5a8b1cec23f3231a19f2bd2a12dc8fed2e864f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Aug 6 14:18:06 2014 +0000

    Increase the thread stack size to at least 4 MB
    
    " Recently I tried to run it on a non-glibc system using musl instead.
    Turns out musl has a default stacksize of 80KB instead of the
    multi-megabyte we are used to in glibc. This leads to segfaults when
    pcscd tries to allocate buffers on the stack. To fix this i applied the
    following patch:
    https://github.com/stef/aports/blob/master/main/pcsc-lite/musl-stacksize.patch
    
    I would be very thankful if you would incorporate this "upstream" so
    that other musl users can happily enjoy pcsc and friends. "
    
    Thanks to Stefan Marsiske for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6948 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils.c | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

commit 63dba923c08b2d46a669af30b30547636d4d3e93
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 29 08:33:27 2014 +0000

    Add ReiserFS support (and maybe some other strange file systems)
    
    "the attached patch fixes incorrect use of the dirent::d_type field. As
    documented in readdir(3) d_type may be set to DT_UNKNOWN, which
    applications must handle properly.
    
    The effect of the bug is that config files are skipped in case the
    config directory is located on a file system that doesn't support d_type
    (e.g. ReiserFS)."
    
    Thanks to Ingo Weinhold for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6944 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/configfile.l | 34 +++++++++++++++++++++++++++-------
 1 file changed, 27 insertions(+), 7 deletions(-)

commit e84f71af281d4a349eadaeab1a3ddb9889d58db7
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Jun 13 15:57:38 2014 +0000

    Change return value of IsClientAuthorized()
    
    The version of IsClientAuthorized() when PolicyKit is not used was not
    similar to the other version.
    
    Fixes Debian bug #751517
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6918 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/auth.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0031a6092b28749ff64313b0fdc0df7be98fe2d0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 5 09:34:15 2014 +0000

    Check udev functions for errors
    
    Prevent the crash reported at:
    https://bugzilla.redhat.com/show_bug.cgi?id=1071243
    
    Thanks to Nikos Mavrogiannopoulos for the patch
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20140602/000039.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6911 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit ed2508f319452b52a2511564a8c9e1b8d10569e5
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Apr 18 19:12:51 2014 +0000

    Move the GNU GPL v3 license in the project root directory
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6888 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/example/GPL-3.0.txt => GPL-3.0.txt | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 2f3599a3e69b71ab5fd37be3c9719e48807ae395
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Apr 18 19:12:24 2014 +0000

    Some files are under GNU GPL v3+ license
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6887 0ce88b0d-b2fd-0310-8134-9614164e65ea

 COPYING | 6 ++++++
 1 file changed, 6 insertions(+)

commit a0c3349bdc379e7d3402578003c3e182c0d41ba7
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Apr 18 19:04:19 2014 +0000

    Replase GNU GPL v2 by GPL v3 license text
    
    Since revision 6003 (2011-10-05) pcsc_demo.c moved from GNU GPL v2+ to
    GNU GPL v3+
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6886 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/example/GPL-2       | 340 ------------------------
 doc/example/GPL-3.0.txt | 674 ++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 674 insertions(+), 340 deletions(-)

commit 3bba4666b0941c9696dcf191cd926859d9728f9a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Feb 26 09:36:01 2014 +0000

    Remove reference about "new MuscleCard" applet
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6861 0ce88b0d-b2fd-0310-8134-9614164e65ea

 NEWS | 5 -----
 1 file changed, 5 deletions(-)

commit 8f71c5f2f17ce3e75af08c62954eabff82a6dbd0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Feb 20 14:02:47 2014 +0000

    Make --disable-polkit
    
    Thanks to Diego Elio Pettenò for the bug report
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6859 0ce88b0d-b2fd-0310-8134-9614164e65ea

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b8a328f5275792032b86fe965a6a4bb561fa7bf1 (tag: pcsc-1.8.11)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Feb 14 16:14:37 2014 +0000

    Release 1.8.11
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6853 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 8 ++++++++
 configure.ac | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit 8f55bf6f961e8a392644b635770d268202297d25
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Feb 14 15:46:13 2014 +0000

    Replace old linuxnet.com domaine name
    
    Mailing list moved from sclinux@linuxnet.com to
    muscle@lists.musclecard.com
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6852 0ce88b0d-b2fd-0310-8134-9614164e65ea

 HELP | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit bc24ebfd6127063d418429f68ab1e2ce672af9e7
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Feb 14 15:43:32 2014 +0000

    Replace old linuxnet.com domaine name
    
    web site moved from http://www.linuxnet.com to
    http://pcsclite.alioth.debian.org/pcsclite.html
    
    David email moved tom corcoran@linuxnet.com to corcoran@musclecard.com
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6851 0ce88b0d-b2fd-0310-8134-9614164e65ea

 AUTHORS                       |  2 +-
 COPYING                       |  2 +-
 DRIVERS                       | 10 +++++-----
 README                        |  2 +-
 UnitaryTests/BufferOverflow.c |  2 +-
 doc/example/pcsc_demo.c       |  2 +-
 src/PCSC/debuglog.h           |  4 ++--
 src/PCSC/ifdhandler.h         |  4 ++--
 src/PCSC/pcsclite.h.in        |  4 ++--
 src/PCSC/reader.h             |  4 ++--
 src/PCSC/winscard.h           |  4 ++--
 src/PCSC/wintypes.h           |  4 ++--
 src/atrhandler.c              |  4 ++--
 src/atrhandler.h              |  4 ++--
 src/auth.c                    |  2 +-
 src/auth.h                    |  2 +-
 src/configfile.h              |  4 ++--
 src/configfile.l              |  4 ++--
 src/debug.c                   |  4 ++--
 src/debuglog.c                |  4 ++--
 src/dyn_generic.h             |  4 ++--
 src/dyn_hpux.c                |  4 ++--
 src/dyn_macosx.c              |  4 ++--
 src/dyn_unix.c                |  4 ++--
 src/error.c                   |  4 ++--
 src/eventhandler.c            |  4 ++--
 src/eventhandler.h            |  4 ++--
 src/hotplug.h                 |  4 ++--
 src/hotplug_generic.c         |  4 ++--
 src/hotplug_libudev.c         |  2 +-
 src/hotplug_libusb.c          |  4 ++--
 src/hotplug_linux.c           |  4 ++--
 src/hotplug_macosx.c          |  4 ++--
 src/ifdwrapper.c              |  4 ++--
 src/ifdwrapper.h              |  4 ++--
 src/misc.h                    |  2 +-
 src/parser.h                  |  2 +-
 src/pcscd.h.in                |  2 +-
 src/pcscdaemon.c              |  6 +++---
 src/powermgt_generic.c        |  4 ++--
 src/powermgt_generic.h        |  4 ++--
 src/prothandler.c             |  4 ++--
 src/prothandler.h             |  4 ++--
 src/readerfactory.c           |  4 ++--
 src/readerfactory.h           |  4 ++--
 src/strlcpycat.h              |  2 +-
 src/sys_generic.h             |  4 ++--
 src/sys_unix.c                |  4 ++--
 src/testpcsc.c                |  4 ++--
 src/tokenparser.l             |  4 ++--
 src/utils.c                   |  2 +-
 src/utils.h                   |  2 +-
 src/utils/README              |  2 +-
 src/utils/formaticc.c         |  4 ++--
 src/utils/installifd.c        |  6 +++---
 src/winscard.c                |  4 ++--
 src/winscard_clnt.c           |  4 ++--
 src/winscard_msg.c            |  4 ++--
 src/winscard_msg.h            |  4 ++--
 src/winscard_msg_srv.c        |  4 ++--
 src/winscard_svc.c            |  4 ++--
 src/winscard_svc.h            |  4 ++--
 62 files changed, 114 insertions(+), 114 deletions(-)

commit 320a5e4b1163b027747f3bc20a116f4aaf8d1502
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Feb 14 15:25:52 2014 +0000

    Fix Muscle URL
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6850 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/auth.c | 2 +-
 src/auth.h | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 230fcfdfe61183361fa72097129ad3e068f90c79
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 11 10:49:20 2014 +0000

    Add polkit support
    
    See doc/README.polkit
    
    Thanks to Nikos Mavrogiannopoulos for the patch
    http://archives.neohapsis.com/archives/dev/muscle/2013-q4/0097.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6842 0ce88b0d-b2fd-0310-8134-9614164e65ea

 configure.ac                    |  25 +++++++
 doc/Makefile.am                 |  14 +++-
 doc/README.polkit               |  39 ++++++++++
 doc/org.debian.pcsc-lite.policy |  30 ++++++++
 src/Makefile.am                 |   6 +-
 src/auth.c                      | 155 ++++++++++++++++++++++++++++++++++++++++
 src/auth.h                      |  35 +++++++++
 src/winscard_svc.c              |  21 ++++++
 8 files changed, 322 insertions(+), 3 deletions(-)

commit 806fb5ad7fca2ef3179c60dc8b539425f2fddc52
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 11 09:45:54 2014 +0000

    SCARD_CONNECT: force a NUL byte to terminate the reader name
    
    The client part may send us anything. So we must enfore the reader name
    is a NUL-byte terminated C-string.
    
    Thanks to Nikos Mavrogiannopoulos for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6841 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_svc.c | 1 +
 1 file changed, 1 insertion(+)

commit 07acaa448b59b7574ed0a17a12340065aadb1e4b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Feb 8 15:28:45 2014 +0000

    Reformat for a better HTML output
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6838 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/pcsc-spy.pod | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 8618dca79e15940a0a7eee53d73241fe98087dad
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jan 13 15:21:25 2014 +0000

    Include the COPYING file in header of file
    
    It will be easier to know the licence used by a file when used outside
    of pcsc-lite.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6822 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/PCSC/debuglog.h      | 26 ++++++++++++++++++++++++++
 src/PCSC/ifdhandler.h    | 26 ++++++++++++++++++++++++++
 src/PCSC/pcsclite.h.in   | 26 ++++++++++++++++++++++++++
 src/PCSC/reader.h        | 26 ++++++++++++++++++++++++++
 src/PCSC/winscard.h      | 26 ++++++++++++++++++++++++++
 src/PCSC/wintypes.h      | 26 ++++++++++++++++++++++++++
 src/atrhandler.c         | 26 ++++++++++++++++++++++++++
 src/atrhandler.h         | 26 ++++++++++++++++++++++++++
 src/configfile.h         | 26 ++++++++++++++++++++++++++
 src/configfile.l         | 26 ++++++++++++++++++++++++++
 src/debug.c              | 26 ++++++++++++++++++++++++++
 src/debuglog.c           | 26 ++++++++++++++++++++++++++
 src/dyn_generic.h        | 26 ++++++++++++++++++++++++++
 src/dyn_hpux.c           | 26 ++++++++++++++++++++++++++
 src/dyn_macosx.c         | 26 ++++++++++++++++++++++++++
 src/dyn_unix.c           | 26 ++++++++++++++++++++++++++
 src/error.c              | 26 ++++++++++++++++++++++++++
 src/eventhandler.c       | 26 ++++++++++++++++++++++++++
 src/eventhandler.h       | 26 ++++++++++++++++++++++++++
 src/hotplug.h            | 26 ++++++++++++++++++++++++++
 src/hotplug_generic.c    | 26 ++++++++++++++++++++++++++
 src/hotplug_libudev.c    | 26 ++++++++++++++++++++++++++
 src/hotplug_libusb.c     | 26 ++++++++++++++++++++++++++
 src/hotplug_linux.c      | 26 ++++++++++++++++++++++++++
 src/hotplug_macosx.c     | 26 ++++++++++++++++++++++++++
 src/ifdwrapper.c         | 26 ++++++++++++++++++++++++++
 src/ifdwrapper.h         | 26 ++++++++++++++++++++++++++
 src/lassert.h            | 27 +++++++++++++++++++++++++++
 src/misc.h               | 26 ++++++++++++++++++++++++++
 src/parser.h             | 26 ++++++++++++++++++++++++++
 src/pcsc-wirecheck-gen.c | 27 +++++++++++++++++++++++++++
 src/pcscdaemon.c         | 26 ++++++++++++++++++++++++++
 src/powermgt_generic.c   | 26 ++++++++++++++++++++++++++
 src/powermgt_generic.h   | 26 ++++++++++++++++++++++++++
 src/prothandler.c        | 26 ++++++++++++++++++++++++++
 src/prothandler.h        | 26 ++++++++++++++++++++++++++
 src/readerfactory.c      | 26 ++++++++++++++++++++++++++
 src/readerfactory.h      | 26 ++++++++++++++++++++++++++
 src/strlcpycat.h         | 26 ++++++++++++++++++++++++++
 src/sys_generic.h        | 26 ++++++++++++++++++++++++++
 src/sys_unix.c           | 26 ++++++++++++++++++++++++++
 src/testpcsc.c           | 26 ++++++++++++++++++++++++++
 src/tokenparser.l        | 26 ++++++++++++++++++++++++++
 src/utils.c              | 26 ++++++++++++++++++++++++++
 src/utils.h              | 26 ++++++++++++++++++++++++++
 src/utils/formaticc.c    | 26 ++++++++++++++++++++++++++
 src/utils/installifd.c   | 26 ++++++++++++++++++++++++++
 src/winscard.c           | 26 ++++++++++++++++++++++++++
 src/winscard_clnt.c      | 26 ++++++++++++++++++++++++++
 src/winscard_msg.c       | 26 ++++++++++++++++++++++++++
 src/winscard_msg.h       | 26 ++++++++++++++++++++++++++
 src/winscard_msg_srv.c   | 26 ++++++++++++++++++++++++++
 src/winscard_svc.c       | 26 ++++++++++++++++++++++++++
 src/winscard_svc.h       | 26 ++++++++++++++++++++++++++
 54 files changed, 1406 insertions(+)

commit 3e4e237a4277bcbcd9dd5a9780a4d734c20facec
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Dec 20 10:19:01 2013 +0000

    SCardListReaders(): fix a memory leak in case of error
    
    Check mszReaders is valid before allocating memory.
    
    Thanks to Ignacio Casal for the bug report
    http://archives.neohapsis.com/archives/dev/muscle/2013-q4/0084.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6810 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 96fad202ae6dd98eb77344653f62570f473ff0d0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Dec 3 07:58:33 2013 +0000

    Add header directory for sys/types.h
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6804 0ce88b0d-b2fd-0310-8134-9614164e65ea

 splint.sh | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 556dbcaec42f3cfdc36b1fd0567521ef3eebcee9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Dec 3 07:51:18 2013 +0000

    Remove very old files used to build on Solaris
    
    " Adding make-dirs plus Makefiles for certain configurations when people
    don't want to try and fix autoconf "
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6803 0ce88b0d-b2fd-0310-8134-9614164e65ea

 make-dirs/Makefile.solaris | 24 ------------------------
 make-dirs/README           |  5 -----
 make-dirs/config.h         | 38 --------------------------------------
 3 files changed, 67 deletions(-)

commit 7735095554d83ab630674c96fac7f59985bbda3e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Dec 2 10:37:22 2013 +0000

    Do not log a critical error if symbol IFDHCreateChannelByName is not
    found in a driver.
    
    Drivers using API v2 of IFDHandler (like openct-ifd.bundle) do not
    provide a IFDHCreateChannelByName symbol. A critical error should not be
    logged since it is a normal behavior.
    
    DYN_GetAddress() has a new parameter: mayfail, to indicate if dlsym(3)
    may fail or not.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6802 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/dyn_generic.h   | 2 +-
 src/dyn_hpux.c      | 6 ++++--
 src/dyn_macosx.c    | 3 ++-
 src/dyn_unix.c      | 6 ++++--
 src/readerfactory.c | 8 ++++----
 5 files changed, 15 insertions(+), 10 deletions(-)

commit d87d75a1cabcfe9b62d2f1cfe9c8fb51d6f399e7
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Oct 24 14:04:14 2013 +0000

    CHANNELID and DEVICENAME are both optional but not at the same time
    
    If the driver uses DEVICENAME you can ignore/unset CHANNELID.
    If the driver uses CHANNELID you can ignore/unset DEVICENAME.
    But you shall configure at least one of the two parameters.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6785 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/configfile.l | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

commit 9e409c17cee98b335ff81561686486dbff07fea3 (tag: pcsc-1.8.10)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Oct 19 16:36:57 2013 +0000

    Release 1.8.10
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6779 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 7 +++++++
 configure.ac | 2 +-
 2 files changed, 8 insertions(+), 1 deletion(-)

commit e8aa17b99013b6836ce32c4500ab762f5f81e46c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Oct 19 16:32:38 2013 +0000

    Fix typo in log message
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6778 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c2cf225eb8ec4c1caa5da068aa28cc2db2a15565
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Oct 18 11:55:13 2013 +0000

    Display the reader name, Pid and Vid
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6775 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/FEATURE_CCID_ESC_COMMAND_Gemalto_features.py | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

commit c5fa38e97e410597081fb992c95db4f500c9cdf4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Oct 18 11:36:41 2013 +0000

    Update the error message if FEATURE_CCID_ESC_COMMAND is not available
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6773 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/FEATURE_CCID_ESC_COMMAND_Gemalto_features.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ebb1b1bc1d762705d51ea6667fc70c52580c7c09
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Oct 18 11:35:33 2013 +0000

    Add more feature parsing
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6772 0ce88b0d-b2fd-0310-8134-9614164e65ea

 .../FEATURE_CCID_ESC_COMMAND_Gemalto_features.py   | 71 ++++++++++++++++------
 1 file changed, 54 insertions(+), 17 deletions(-)

commit 6535d883c9a360f9cda644bb9663e0229d68fdde
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Oct 17 13:02:41 2013 +0000

    Do not export log_msg() symbol
    
    PCSC_API must be undefined so that log_msg() declaration in
    PCSC/debuglog.h is not external but internal.
    
    Fix alioth bug [#314494] log_msg should NOT be exported by libpscslite.so.1
    https://alioth.debian.org/tracker/index.php?func=detail&aid=314494&group_id=30105&atid=410085
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6771 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/debug.c | 2 ++
 1 file changed, 2 insertions(+)

commit 190ff98475471aebae1ab1cebf2c30ca3ca43c8e (tag: pcsc-1.8.9)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Oct 16 14:28:36 2013 +0000

    Release 1.8.9
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6769 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 45 +++++++++++++++++++++++++++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 46 insertions(+), 1 deletion(-)

commit 0d8aa0662455356ca664c9a12881fdf9bb4f5794
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Oct 1 12:57:03 2013 +0000

    Use the COUNT_OF macro
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6759 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/debug.c         | 3 ++-
 src/debuglog.c      | 2 +-
 src/hotplug_linux.c | 4 ++--
 3 files changed, 5 insertions(+), 4 deletions(-)

commit 7847b99eccb9e9862a21db8f8744de0ecfa14370
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Oct 1 12:55:58 2013 +0000

    Add COUNT_OF macro
    
    This macro returns the number of elements in an array.
    
    See http://stackoverflow.com/questions/1598773
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6758 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/misc.h | 4 ++++
 1 file changed, 4 insertions(+)

commit 674622d814afc5313644b505c5c4826138cef1d8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Sep 12 14:52:08 2013 +0000

    Add support of --reader-name-no-serial and --reader-name-no-interface
    
    It is now possible to NOT add the USB serial number of the reader using
    --reader-name-no-serial
    
    It is now possible to NOT add the CCID interface name of the reader using
    --reader-name-no-interface
    
    See also "What is in a PC/SC reader name?"
    http://ludovicrousseau.blogspot.fr/2010/05/what-is-in-pcsc-reader-name.html
    
    Closes Alioth bug [#314338] Add an option to remove serial number and interface name from the PC/CS reader name
    https://alioth.debian.org/tracker/index.php?func=detail&aid=314338&group_id=30105&atid=410088
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6750 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 15 +++++++--------
 src/hotplug_libusb.c  |  7 +++----
 src/pcscdaemon.c      | 16 +++++++++++++++-
 3 files changed, 25 insertions(+), 13 deletions(-)

commit 5c8ed79c89be2219f48aec9cbbe1481cfe36d748
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 10 18:31:48 2013 +0000

    Unitary test for the correction in revision 6748
    
    SCardEndTransaction() should return SCARD_E_NOT_TRANSACTED if called
    more times than SCardBeginTransaction()
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6749 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/SCardEndTransaction_extra_call.py | 60 ++++++++++++++++++++++++++
 1 file changed, 60 insertions(+)

commit ccc1571ed38131a76a328046fc151b636a974b54
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Sep 10 18:28:44 2013 +0000

    Return an error if SCardEndTransaction() is called with no corresponding
    SCardBeginTransaction()
    
    This is done in two steps:
    - RFUnlockSharing() returns an error if a reader is unlocked when it was
      not (or no more) previously locked
    - SCardEndTransaction() checks the value returned by RFUnlockSharing()
      and returns an error if RFUnlockSharing() failed
    
    Thanks to Markus Heintel for the initial patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6748 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 9 +++++++--
 src/winscard.c      | 9 ++++++++-
 2 files changed, 15 insertions(+), 3 deletions(-)

commit 2a85b30660648a71ab3cc087a9abb17686062236
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 26 15:08:52 2013 +0000

    Document --max-thread, --max-card-handle-per-thread and --max-card-handle-per-reader
    
    Closes bug [#314308] "Document --max-thread,
    --max-card-handle-per-thread and --max-card-handle-per-reader in
    pcscd(8)"
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6744 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit d68ff5d317022a55ab2b639919f273f6292ff76b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 26 14:47:05 2013 +0000

    Document --force-reader-polling
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6743 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 3 +++
 1 file changed, 3 insertions(+)

commit 362fc8da4ed28497b4b121830390fd77a7259f0e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 26 14:46:03 2013 +0000

    Document short options -e, --error and -C, --critical
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6742 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a879c36915e81af6bb33ce191d2fe99107ca01d4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 26 14:44:12 2013 +0000

    Add documentation for -T, --color
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6741 0ce88b0d-b2fd-0310-8134-9614164e65ea

 doc/pcscd.8.in | 3 +++
 1 file changed, 3 insertions(+)

commit 2f0f9267455887d1f5cbaeaa357361c2792d4b2e
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 23 08:19:08 2013 +0000

    Fix a memory leak in case of error
    
    When SCARD_AUTOALLOCATE is used we check the parameter is valid and
    return in case it is not _before_ calling malloc.
    
    Detected by "clang --analyze"
    winscard_clnt.c:1566:9: warning: Potential leak of memory pointed to by 'bufReader'
         rv = SCARD_E_INVALID_PARAMETER;
              ^~~~~~~~~~~~~~~~~~~~~~~~~
    
    winscard_clnt.c:1594:9: warning: Potential leak of memory pointed to by 'bufAtr'
         rv = SCARD_E_INVALID_PARAMETER;
              ^~~~~~~~~~~~~~~~~~~~~~~~~
    
    winscard_clnt.c:3141:9: warning: Potential leak of memory pointed to by 'buf'
          rv = SCARD_E_INVALID_PARAMETER;
               ^~~~~~~~~~~~~~~~~~~~~~~~~
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6734 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 30 +++++++++++++++---------------
 1 file changed, 15 insertions(+), 15 deletions(-)

commit 8942d6049586f34ace0c1c4cdbf3609fc8e4e597
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 12 13:21:40 2013 +0000

    Display SCardTransmit() error code (if any)
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6727 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils/formaticc.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit d65abf9dabb2cc486b2a77b5194aca88336259f2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 12 13:20:22 2013 +0000

    Allow comments starting with #
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6726 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils/formaticc.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 7647b0ddd97bc6b6a0ecbf132188008a7805e26b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 12 12:53:58 2013 +0000

    Display APDU sent and data received
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6725 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils/formaticc.c | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

commit dc60d45ed65fdce7558a97ed3ede7a39fd9b265d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 12 12:42:01 2013 +0000

    Add more error code management
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6724 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils/formaticc.c | 59 ++++++++++++++++++++++++++++++++++-----------------
 1 file changed, 39 insertions(+), 20 deletions(-)

commit f1831de4f7e740330f0ea78b54578155c29b4d93
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 12 09:44:43 2013 +0000

    Mac OS X port
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6723 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils/formaticc.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 493dc11ecef243aa8ff532986ee9cd9c147ff2f4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Aug 7 16:50:19 2013 +0000

    Fix compiler warning
    
    configfile.l: In function ‘evaluatetoken’:
    configfile.l:186: warning: initialization discards qualifiers from pointer target type
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6719 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/configfile.l | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5e2668ab57230150b70cfed6615d046d7d3489ee
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 5 19:11:47 2013 +0000

    Fix memory leak
    
    Call yylex_destroy() after the lexer is used.
    
    Thanks to Alan Kozlay for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6712 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/configfile.l  | 1 +
 src/tokenparser.l | 1 +
 2 files changed, 2 insertions(+)

commit aef84e2263cf95263e948d269060a4a53e396faf
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 5 18:59:56 2013 +0000

    Create and use EHDeinitializeEventStructures(): fix memory leak
    
    The structures allocated in EHInitializeEventStructures() were never
    released.
    
    Thanks to Alan Kozlay for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6711 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/eventhandler.c | 8 ++++++++
 src/eventhandler.h | 1 +
 src/pcscdaemon.c   | 2 ++
 3 files changed, 11 insertions(+)

commit bf4c5d03168e14bf64db011869c49edc3f3960f8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 5 18:53:24 2013 +0000

    SVCServiceRunLoop(): be able to quit earlier
    
    The daemon is now able to quit (test the arakiri flag) even before
    SVCServiceRunLoop() has been called.
    
    Thanks to Alan Kozlay for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6710 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 28 ++++++++++++++--------------
 1 file changed, 14 insertions(+), 14 deletions(-)

commit 2627ba0ef1a11d6295f4240eeaccb29f85fa582c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 5 18:49:31 2013 +0000

    ContextsDeinitialize(): fix a memory leak
    
    Thanks to Alan Kozlay for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6709 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_svc.c | 2 ++
 1 file changed, 2 insertions(+)

commit 4a1412293846dd7219394e05f266f432d4e22347
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 5 18:42:29 2013 +0000

    RFCleanupReaders(): fix a memory leak
    
    Free the ConfigFile C-string if needed
    
    Thanks to Alan Kozlay for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6708 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit a500a7613786a4b35efbd23c51c593514621913d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Aug 5 18:38:40 2013 +0000

    RFCleanupReaders(): fix a memory leak
    
    The sReadersContexts[i] structure allocated in RFAllocateReaderSpace()
    was never released on exit.
    
    This is not really a problem unless you embedd pcscd in another process
    and do init/deinit pcscd without exiting the process (as maybe used on
    Android or iOS).
    
    Thanks to Alan Kozlay for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6707 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 2 ++
 1 file changed, 2 insertions(+)

commit e0d558cf16ca8f5ceed9f0e04dcf897b01303044
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 1 09:25:47 2013 +0000

    Fix memory leaks
    
    Free the malloc-ed strings.
    
    The strings are only allocated _once_ when the config files in
    /etc/reader.conf.d/ are parsed. This is not really a problem unless you
    embedd pcscd in another process and do init/deinit pcscd without exiting
    the process (as maybe used on Android or iOS).
    
    Thanks to Alan Kozlay for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6703 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/configfile.l | 13 +++++++++++--
 1 file changed, 11 insertions(+), 2 deletions(-)

commit d04cc74a995caca7aec979d35338103ed13be233
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jul 31 17:16:54 2013 +0000

    Fix compiler warnings
    
    pcscdaemon.c: In function ‘main’:
    pcscdaemon.c:547:12: attention : declaration of ‘r’ shadows a previous local [-Wshadow]
    pcscdaemon.c:152:6: attention : shadowed declaration is here [-Wshadow]
    pcscdaemon.c:637:11: attention : declaration of ‘r’ shadows a previous local [-Wshadow]
    pcscdaemon.c:152:6: attention : shadowed declaration is here [-Wshadow]
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6702 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 5994b622fb098001c461b241b6ead068b83fc513
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 13:10:21 2013 +0000

    Fix compiler warning
    
    atrhandler.c: In function ‘ATRDecodeAtr’:
    atrhandler.c:88:19: warning: variable ‘TCi’ set but not used [-Wunused-but-set-variable]
    atrhandler.c:88:14: warning: variable ‘TBi’ set but not used [-Wunused-but-set-variable]
    
    We don't use TBi and TCi but we must calculate them because of the p++
    in the formulae.
    
    See revision 5808 to know why these values are important.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6701 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/atrhandler.c | 5 +++++
 1 file changed, 5 insertions(+)

commit b61e1310a78c85ebf7a3df8a03fb769426f141e2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 13:05:52 2013 +0000

    Check returned value of fgets(3)
    
    Fix compiler warning:
    testpcsc.c: In function ‘main’:
    testpcsc.c:190:4: warning: ignoring return value of ‘fgets’, declared with attribute warn_unused_result [-Wunused-result]
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6700 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/testpcsc.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 67a10b34222803be09db782d7fca7a3f3f72cf56
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 13:02:54 2013 +0000

    Check returned value of write(2) on synchronization socket
    
    Fix compiler warnings:
    pcscdaemon.c: In function ‘main’:
    pcscdaemon.c:639:3: warning: ignoring return value of ‘write’, declared with attribute warn_unused_result [-Wunused-result]
    pcscdaemon.c: In function ‘at_exit’:
    pcscdaemon.c:661:3: warning: ignoring return value of ‘write’, declared with attribute warn_unused_result [-Wunused-result]
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6699 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit 6ac5603fe8d054fb8f4c8f2cfb7759178a88d9a2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 12:59:14 2013 +0000

    Check returned value from chdir(2)
    
    Fix compiler warning:
    pcscdaemon.c: In function ‘main’:
    pcscdaemon.c:401:2: warning: ignoring return value of ‘chdir’, declared with attribute warn_unused_result [-Wunused-result]
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6698 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit e23fbed33a1183c50d11c6598ab550a000a563e0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 12:56:20 2013 +0000

    Add the terminating \0 in pcscd.pid file
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6697 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5c5a2fa152bdfc8e135e5d2c45a2aac4b6eb6b25
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 12:55:15 2013 +0000

    Check read(2) and write(2) returned value for pcscd.pid file
    
    Fix compiler warnings:
    utils.c: In function `GetDaemonPid':
    utils.c:45:3: warning: ignoring return value of `read', declared with attribute warn_unused_result [-Wunused-result]
    pcscdaemon.c: In function ‘main’:
    pcscdaemon.c:543:4: warning: ignoring return value of ‘write’, declared with attribute warn_unused_result [-Wunused-result]
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6696 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c |  9 ++++++++-
 src/utils.c      | 12 ++++++++++--
 2 files changed, 18 insertions(+), 3 deletions(-)

commit 6e955580e0ac7953a1642352d855e484bd940733
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 12:41:23 2013 +0000

    Ignore the write(2) returned value
    
    Using (void)write(...) is not enough to fool the compiler. I still get:
    libpcscspy.c: In function `spy_line':
    libpcscspy.c:200:2: warning: ignoring return value of `write', declared with attribute warn_unused_result [-Wunused-result]
    libpcscspy.c:201:2: warning: ignoring return value of `write', declared with attribute warn_unused_result [-Wunused-result]
    libpcscspy.c:202:2: warning: ignoring return value of `write', declared with attribute warn_unused_result [-Wunused-result]
    libpcscspy.c: In function `spy_line_direct':
    libpcscspy.c:173:2: warning: ignoring return value of `write', declared with attribute warn_unused_result [-Wunused-result]
    libpcscspy.c:174:2: warning: ignoring return value of `write', declared with attribute warn_unused_result [-Wunused-result]
    libpcscspy.c:175:2: warning: ignoring return value of `write', declared with attribute warn_unused_result [-Wunused-result]
    
    The new code now uses:
    ssize_t r;
    r = write(...)
    (void)r;
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6695 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/libpcscspy.c | 16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

commit b31cd11442865f7615e09dec49b7835e9ea86661
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jul 30 12:36:46 2013 +0000

    Update Copyright date
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6694 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/libpcscspy.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b4d935a73e84b899dbf63bc97bca0c50c9b84f5b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jul 1 08:34:26 2013 +0000

    Do not use pthread_atfork() any more
    
    pthread_atfork() was used to invalidate all the handles after a fork.
    The problem is that the handler function was still called after the
    libpcsclite library was unloaded on FreeBSD. This caused a crash of the
    application.
    
    The invalidation of the handles is not mandatory. After a fork the
    application may still use the PC/SC handles and may get a
    SCARD_F_COMM_ERROR error if the handle has been closed and in the pcscd logs:
    winscard_svc.c:908:MSGCheckHandleAssociation() Client failed to authenticate
    
    Closes Alioth bug [#314078] Do not use pthread_atfork() in a library
    https://alioth.debian.org/tracker/index.php?func=detail&aid=314078&group_id=30105&atid=410085
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6680 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 30 ------------------------------
 1 file changed, 30 deletions(-)

commit 2699ee0375239d05058fe4f30c8d62a1734f1df0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 27 21:11:43 2013 +0000

    Fix compiler warning
    
    hotplug_macosx.c:298: warning: format ‘%s’ expects type ‘char *’, but
    argument 6 has type ‘struct HPDriver *’
    hotplug_macosx.c:298: warning: too many arguments for format
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6671 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_macosx.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6c53462964cca9015d198a421930c8ae045f7b44
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 27 21:07:42 2013 +0000

    List found USB devices (when in debug mode)
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6670 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_macosx.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit d7ba6bc80452643f065362faefef6a1127938018
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jun 25 13:18:22 2013 +0000

    Fix copy-paster in log message
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6669 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/SCard_fork.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 131c5abe84687063499f1265037892a29a6f2775
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jun 25 12:23:21 2013 +0000

    RFAddReader(): correctly manage thread safe multi-slot readers
    
    If the driver declares it is TAG_IFD_SLOT_THREAD_SAFE then pcscd can
    access each slots simultanously.
    
    In this case some data must be duplicated at RFAddReader() step since
    they will be destroyed at the removeReader() step.
    
    Thanks to Frank Morgner for the bug report
    Closes Alioth bug [#314315] "double free corruption when unloading serial
    driver with multiple slots"
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6668 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit a56039dc0ec76503b2e7aaa67789c6b4a44e5610
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jun 18 08:56:16 2013 +0000

    Add support of serialconfdir pkg-config variable
    
    It is now possible to use pkg-config to get the directory used by pcscd
    to fetch serial drivers configurations.
    
    $ pkg-config libpcsclite --variable=serialconfdir
    /etc/reader.conf.d
    
    Closes alioth bug [#314300] Add pkg-config confdir option
    Thanks to Frank Morgner for the idea
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6663 0ce88b0d-b2fd-0310-8134-9614164e65ea

 configure.ac          | 2 ++
 src/libpcsclite.pc.in | 1 +
 2 files changed, 3 insertions(+)

commit 7d4e8c4a7d2abffe1a9800bc38653e681001e34f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jun 10 12:28:42 2013 +0000

    SCardGetAttrib(): Add support of SCARD_ATTR_DEVICE_SYSTEM_NAME
    
    Thanks to Rafael Ugalde Beriain
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6654 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit db605205152489205a0bb3a63abc9a96f276c4d7
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jun 10 12:21:32 2013 +0000

    SCardGetAttrib(): Fix bug in SCARD_ATTR_DEVICE_FRIENDLY_NAME
    
    Affect the real length _after_ checking the buffer is large enough.
    
    Thanks to Rafael Ugalde Beriain for the bug report.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6653 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 330178c65eaa4455a335798a88bab4ebca20aba6
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 6 17:10:50 2013 +0000

    Fix PEP8 warnings
    
    E128 continuation line under-indented for visual indent
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6649 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/pcsc-spy | 98 ++++++++++++++++++++++++++++----------------------------
 1 file changed, 49 insertions(+), 49 deletions(-)

commit a6313f39fe1fc5fc1e082950d34bcb819a344ca9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 6 16:56:47 2013 +0000

    Fix PEP8 warning
    
    pcsc-spy:34:13: E128 continuation line under-indented for visual indent
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6648 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/pcsc-spy | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit da09e5d30dc6ec4689d5e7cef40ffd8ee652cccf
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Jun 6 16:55:22 2013 +0000

    Add SCARD_ATTR_DEVICE_SYSTEM_NAME
    
    Add _A and _W versions
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6647 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/pcsc-spy | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit a6b8e6e4fe98b96a5318ac21c99378fc1a700b44
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu May 30 11:21:05 2013 +0000

    Unlock the mutex if hCard has been invalidated by SCardDisconnect()
    
    SCardBeginTransaction() was not correctly releasing a mutex when the
    hCard handle was invalidated.
    The problem is that hCard can be invalidated by:
    - SCardReleaseContext and all the context is invalid
    - SCardDisconnect and only the hCard is invalid, not the mutex
    
    The problem was that SCardGetStatusChange() was blocked because
    SCardBeginTransaction() had not released the context mutex.
    
    Thanks to Fredrik Axelsson for the bug report
    https://bugzilla.redhat.com/show_bug.cgi?id=956530
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6639 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 94 +++++++++++++++++++++++++++++++++++++++--------------
 1 file changed, 70 insertions(+), 24 deletions(-)

commit f252b3e0e4cb6416ae381a189ed8e2cc5d95aa88
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue May 28 08:20:15 2013 +0000

    Use C99 flexible array member
    
    The structures PIN_MODIFY_STRUCTURE and PIN_VERIFY_STRUCTURE now use a
    C99 flexible array member when available for abData field.
    
    uint8_t abData[];
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6638 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/PCSC/reader.h | 16 ++++++++++++++--
 1 file changed, 14 insertions(+), 2 deletions(-)

commit 0cbd25736fcc90fed6d6389d9977a36cf4028247
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon May 27 13:47:37 2013 +0000

    mMutex is now directly inside the _psContextMap structure and no more a pointer
    
    The mutex was dynamically allocated at runtime using malloc(3) and
    referenced using a pointer. This was introduced in revision 572 (Dec
    2003) by Damien Sauveron.
    
    Using a direct pthread_mutex_t structure will save memory (one pointer
    removed per context), improve performances (one malloc/free removed) and
    make the code safer (one malloc failure removed).
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6637 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_clnt.c | 78 +++++++++++++++++++++++------------------------------
 1 file changed, 34 insertions(+), 44 deletions(-)

commit b13d3c9db6b14d496170d43f70f43afb456e81df
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed May 8 11:51:09 2013 +0000

    Explicitely ignore write() return value
    
    pcscdaemon.c:626:3: warning: ignoring return value of function declared with warn_unused_result attribute [-Wunused-result]
                    write(pipefd[1], &buf, 1);
                    ^~~~~ ~~~~~~~~~~~~~~~~~~
    pcscdaemon.c:648:3: warning: ignoring return value of function declared with warn_unused_result attribute [-Wunused-result]
                    write(pipefd[1], &buf, 1);
                    ^~~~~ ~~~~~~~~~~~~~~~~~~
    2 warnings generated.
    
    We don't have much to do if write() on the interprocess pipe fails.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6625 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit eeefadc062f0f936bebc583f830328dd9cc8423a
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sun May 5 13:18:00 2013 +0000

    Fix a memory leak in case of error
    
    Coverity: leaked_storage: Variable "hpDir" going out of scope leaks the storage it points to.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6621 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 1 +
 1 file changed, 1 insertion(+)

commit 4b3a0af859890e25bcd0ef259fe00a43047fd8c6
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 29 19:42:28 2013 +0000

    Try to display the thread in the order they appear in the log
    
    The idea is to schedule another thread when a thread change is detected
    in the log. Then the other threads should have time to empty their
    queues and display what they have to display.
    The order is then respected between the logs recorded and the logs
    displayed.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6582 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/pcsc-spy | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 18bc7dd2f7a466e1627e0d99e27202ceea582ba3
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 29 16:44:47 2013 +0000

    Check the first line format
    
    This could happen if the trace file first lines are removed.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6581 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/pcsc-spy | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit 325c595f017fce9cac1f1fea0a6e59292029901f
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 29 10:08:37 2013 +0000

    Do not explicitly include the .in files in Makefile.am
    
    These files are automatically included.
    
    Thanks to Anthony Foiani for the patch
    http://sourceforge.net/mailarchive/message.php?msg_id=30653233
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6580 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/Makefile.am | 2 --
 1 file changed, 2 deletions(-)

commit 2c7ef49153bdc7a47730b525679e62d353c1a78c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Mar 29 09:58:04 2013 +0000

    Use $(srcdir) to locate pcsc-spy.pod
    
    Without the patch it is not possible to build pcsc-lite out of the
    source tree like:
    
    mkdir build
    cd build
    ../configure
    make
    
    Thanks to Anthony Foiani for the bug report
    http://sourceforge.net/mailarchive/message.php?msg_id=30653233
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6579 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b79d51e3fb011514a441d2cfddaf4c294dff22d9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Mar 16 17:19:47 2013 +0000

    $^ not supported on FreeBSD make
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6574 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5a82978c2ce7849e97947fa50e4695eab70dd70b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Mar 16 14:32:24 2013 +0000

    Do not use GNU make extension
    
    src/spy/Makefile.am:11: `%'-style pattern rules are a GNU make extension
    
    Thanks to Martin Paljak for the patch
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20130311/000016.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6573 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d3d4e513f831b29f649ec24c9133feda615872d6
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Sat Mar 16 14:29:49 2013 +0000

    Fix OpenBSD 5.2 compilation regarding dlopen
    
    1) dlopen search in configure.ac, as guided in [1]. Removes this
    warning:
    * Warning: linker path does not have real file for library -ldl.
    * I have the capability to make that library automatically link in when
    * you link to this library.  But I can only do this if you have a
    * shared version of the library, which you do not appear to have
    * because I did check the linker path looking for a file starting
    * with libdl but no candidates were found. (...for regex pattern test)
    * The inter-library dependencies that have been dropped here will be
    * automatically added whenever a program is linked with this library
    * or is declared to -dlopen it.
    
    [1] http://www.flameeyes.eu/autotools-mythbuster/autoconf/finding.html
    
    Thanks to Martin Paljak for the patch
    http://lists.alioth.debian.org/pipermail/pcsclite-muscle/Week-of-Mon-20130311/000016.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6572 0ce88b0d-b2fd-0310-8134-9614164e65ea

 configure.ac        | 5 +++--
 src/Makefile.am     | 2 +-
 src/spy/Makefile.am | 1 -
 3 files changed, 4 insertions(+), 4 deletions(-)

commit 287b5a89e9b0dd5d8ade9be1344a529f3dcf28b4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 14:12:49 2013 +0000

    cppcheck: Variable 'rv' is reassigned a value before the old one has
    been used.
    
    This is a (minor) performance issue. I guess the compiler can optimize
    the code as needed.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6558 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/ifdwrapper.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit c9dfe6ec2e5c17990c694ffa5b9fdd00a15fcbb4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 14:10:20 2013 +0000

    cppcheck: The scope of the variable 'fullname' can be reduced.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6557 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libusb.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit b0046513e832f2974b9333c7f38c522ccdff7fc8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 14:09:42 2013 +0000

    cppcheck: The scope of the variable 'serialNumber' can be reduced.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6556 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libusb.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit abb393e26eb736bbaf584e170a378299950cccf8
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 14:09:16 2013 +0000

    cppcheck: The scope of the variable 'lrv' can be reduced.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6555 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_svc.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit f972106fbe32d7bd31ddbdaef70b5a654ec18440
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 13:55:26 2013 +0000

    cppcheck: Resource leak: fp
    
    Same problem with FILE descriptor fo
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6554 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/utils/formaticc.c | 2 ++
 1 file changed, 2 insertions(+)

commit dbd1c81bbc21a8b1cd7b6ab825d8027f26861ba0
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 13:52:59 2013 +0000

    cppcheck: Variable 'readerState' is assigned a value that is never used.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6553 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/eventhandler.c | 1 -
 1 file changed, 1 deletion(-)

commit 71d20234720d7416ea9aedcc83e79d1ea1aa5b7d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 13:49:59 2013 +0000

    cppcheck: Unused variable: dwAtrLen
    
    dwAtrLen is used only if DISABLE_AUTO_POWER_ON is not set (default case)
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6552 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/eventhandler.c | 2 ++
 1 file changed, 2 insertions(+)

commit 1c0c744d633bf5ed77a37e277225a4bb5d8bbcc2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 13:44:17 2013 +0000

    cppcheck: The scope of the variable 'terms' can be reduced.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6551 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/debug.c    | 2 +-
 src/debuglog.c | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 165f90e94644aa1b2535eae3296ab3ba22468343
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Mar 6 13:32:21 2013 +0000

    cppcheck: The scope of the variable 'i' can be reduced.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6550 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/BufferOverflow.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 23adb12513585b98ba1ddc93d520123bb5c61a2c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Mar 4 13:15:44 2013 +0000

    Update PROTOCOL_VERSION_MINOR from 2 to 3
    
    We broke the API between version 1.8.3 and 1.8.4 by changing the value
    of MAX_READERNAME.
    
    This change should have been made before releasing version 1.8.4 to make
    mix of versions clearly non working instead of failing with strange
    errors.
    
    This may be the source of the bug reported at
    http://archives.neohapsis.com/archives/dev/muscle/2012-q3/0065.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6549 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_msg.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 59d93125533ead6679cb023709c18c4cd77abfe2
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 19 10:41:20 2013 +0000

    Remove duplicated line found by scan-build(1)
    
    Assigned value is always the same as the existing value
    
    The same line is also present in the case (rv == SCARD_S_SUCCESS)
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6536 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard.c | 1 -
 1 file changed, 1 deletion(-)

commit 82e38701e585b5731671c35373bf946136d7aa55
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 19 10:34:02 2013 +0000

    Fix a bug reported by scan-build(1)
    
    Value stored to 'retval' is never read
    
    An else statement was missing
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6535 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_svc.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 8d94d1f453057c7c3043bbe1fcf02856cefe3d4d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Feb 19 10:30:32 2013 +0000

    Initialize iList[] to fix a error reported by scan-build(1)
    
    scan-build(1) from clang reported a problem that iList[iReader] migth be
    used uninitialized.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6534 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/testpcsc.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0e9fffba6defc6a369d3d0d968162bf5f05133e3
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Feb 13 16:47:47 2013 +0000

    Add some debug logs
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6527 0ce88b0d-b2fd-0310-8134-9614164e65ea

 UnitaryTests/SCard_fork.py | 10 +++++++---
 1 file changed, 7 insertions(+), 3 deletions(-)

commit d334bf0bbcf5e141fc121371d462481885bbe7ff
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jan 28 15:58:47 2013 +0000

    Check the Info.plist file is (a minimum) correct
    
    The number of products, manufacturers and reader names should be the
    same. Otherwise the Info.plist file is corrupted and bad things may
    happen, like a crash of pcscd.
    
    Thanks to Nikita Bige for the bug report
    https://bugzilla.redhat.com/show_bug.cgi?id=904932
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6519 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/hotplug_libudev.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 90c56c256aed6214f5563860e90809a9bbae81b4
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Jan 21 10:54:41 2013 +0000

    Explicitly ignore the result of write(2)
    
    Even if write(2) fails the show must go on. The spy log may get
    corrupted but we can't do much better.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6511 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/spy/libpcscspy.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 38efc7204e71c5aa1ececb5af610008ffdae0e3b (tag: pcsc-1.8.8)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jan 16 14:51:12 2013 +0000

    Release 1.8.8
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6505 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 5 +++++
 configure.ac | 2 +-
 2 files changed, 6 insertions(+), 1 deletion(-)

commit 1f9311dc4f0becbc071f938458a14307758dfc94
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jan 16 14:22:26 2013 +0000

    Convert all the &amp; in &, not just the first occurence
    
    Reader names may use more than one "&" character.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6504 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/tokenparser.l | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit ef1defbc04d88a039c80b8404577a1fd410de002
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Jan 16 14:00:25 2013 +0000

    Correctly terminate reader names containing a & sign
    
    The & is a &amp; in the Info.plist XML file and converted back to & by
    the Lexer. Unfortunately the string was not correctly terminated and the
    4 last characters of the reader name were duplicated.
    
    Thanks to Philippe Teuwen for the bug report.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6503 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/tokenparser.l | 2 ++
 1 file changed, 2 insertions(+)

commit a8d3938ed4fd70fea720083afa9e46de15b1857b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jan 15 19:30:07 2013 +0000

    Fix a typo in comment
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6502 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/tokenparser.l | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5690441d062e6a45fa520b3bc2c31b72f99cd798
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jan 15 19:28:04 2013 +0000

    Correctly calculate the FRIENDLYNAME field string size
    
    If the FRIENDLYNAME field is NOT delimited by " then the string length
    was wrong and a buffer overflow occured.
    
    Thanks to Alan Kozlay for the bug report and patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6501 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/configfile.l | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d82e703ad2f5f1fba291de910fc8cff227e07328
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Tue Jan 15 17:42:13 2013 +0000

    Move the variable declaration near there use site
    
    Also
    - change the type from int to size_t for strlen() results
    - initialize the values in the for() loop
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6500 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/configfile.l | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit a34bd69e5ae45cc65722d181126661ca31e6fe5e (tag: pcsc-1.8.7)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Nov 28 17:41:48 2012 +0000

    Release 1.8.7
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6490 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 5 +++++
 configure.ac | 2 +-
 2 files changed, 6 insertions(+), 1 deletion(-)

commit 81b430104e805a7f74ce2b71a261caff411ff03b
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Wed Nov 28 17:23:40 2012 +0000

    Fix typos
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6489 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit 0a228a44486186a6e50888836591418932b5d49c
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Oct 22 09:26:17 2012 +0000

    Ignore some new files
    
    svn propedit svn:ignore  .
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6477 0ce88b0d-b2fd-0310-8134-9614164e65ea

commit 2006c826f410f0e6aeafc3fcc2f1dbe8f55a1ac9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Mon Oct 22 09:20:17 2012 +0000

    Ignore some new files
    
    svn propedit svn:ignore  .
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6476 0ce88b0d-b2fd-0310-8134-9614164e65ea

commit 37a42fc6bdb819bac8b4f8210e24a1e44aab2fb9
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Oct 4 16:04:23 2012 +0000

    Rename configure.in in configure.ac
    
    aclocal: warning: autoconf input should be named 'configure.ac', not 'configure.in'
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6468 0ce88b0d-b2fd-0310-8134-9614164e65ea

 configure.in => configure.ac | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 9ed7b00036c41189e93594b2286118977974dafb
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Sep 13 17:16:41 2012 +0000

    FCreateReaderHandle(): unref a reader when needed
    
    We should call UNREF_READER() only if RFReaderInfoById() returned with
    success. Fix a bug introduced in revision 6459.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6463 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ea9524b270c5e62ce94035ca2be8aaf8d200ddc6
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Sep 13 17:11:32 2012 +0000

    MSGRemoveContext(): Unref the reader
    
    RFReaderInfoById() is called and implicitely increase the reader
    reference count. So we shall call UNREF_READER() before exiting.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6462 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/winscard_svc.c | 2 ++
 1 file changed, 2 insertions(+)

commit 940368372e1148370e1976f5b3171ef1210d592d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Sep 13 17:08:37 2012 +0000

    RFCreateReaderHandle(): reorganize code
    
    Move a variable declaration to the inner block using the variable.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6461 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ee8fe306217e1c854584b6ebf63de1b1fc762c7d
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Sep 13 16:39:12 2012 +0000

    Remove extra ;
    
    UNREF_READER() is a { } block in a macro
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6460 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 36948c3ef09dc20c3b228d30cd73250dc27250f3
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Sep 13 16:30:56 2012 +0000

    RFCreateReaderHandle(): Unref the reader is the handle is already used
    
    The function RFCreateReaderHandle() checks if a handle is already used
    by calling RFReaderInfoById() to find the associated reader.
    
    So if RFReaderInfoById() returns with success then the handle is valid
    and can't be used. A new random handle must be generated.
    
    But since RFReaderInfoById() called REF_READER() internally we must call
    UNREF_READER() to decrement the reference counter.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6459 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 1 +
 1 file changed, 1 insertion(+)

commit 24a3c0e2c024da7218901b91434defe13dcd7237
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Sep 13 15:35:12 2012 +0000

    Make hLockId field volatile
    
    The ReaderContext structure is accessed from different pcscd threads. To
    prevent the compiler to optimise read access to the hLockId field we
    make it volatile.
    
    That may be the source of a problem when a reader is removed but pcscd
    do not behave correctly.
    
    Thanks to Torsten Hilbrich for the idea.
    http://archives.neohapsis.com/archives/dev/muscle/2012-q3/0086.html
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6458 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 999e10a7a93705fb803257ca73218d83ea872bf3
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 30 16:55:11 2012 +0000

    USe ax_pthread.m4 instead of acx_pthread.m4
    
    Fix "autoreconf -vis -Wall" warnings:
    configure.in:75: warning: The macro `AC_LANG_SAVE' is obsolete.
    configure.in:75: You should run autoupdate.
    ../../lib/autoconf/lang.m4:128: AC_LANG_SAVE is expanded from...
    m4/acx_pthread.m4:275: ACX_PTHREAD is expanded from...
    configure.in:75: the top level
    configure.in:75: warning: The macro `AC_LANG_C' is obsolete.
    configure.in:75: You should run autoupdate.
    ../../lib/autoconf/c.m4:72: AC_LANG_C is expanded from...
    m4/acx_pthread.m4:275: ACX_PTHREAD is expanded from...
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6451 0ce88b0d-b2fd-0310-8134-9614164e65ea

 Makefile.am                          |   2 +-
 configure.in                         |   5 +-
 m4/{acx_pthread.m4 => ax_pthread.m4} | 142 ++++++++++++++++++++++-------------
 3 files changed, 91 insertions(+), 58 deletions(-)

commit c7c140d327adf07ab477eedd2fee38781bce35e5 (tag: pcsc-1.8.6)
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Thu Aug 30 16:25:19 2012 +0000

    Release 1.8.6
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6450 0ce88b0d-b2fd-0310-8134-9614164e65ea

 ChangeLog    | 11 +++++++++++
 configure.in |  2 +-
 2 files changed, 12 insertions(+), 1 deletion(-)

commit 9c5417d366fc019822e998ff235a2218d268d1fd
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 24 15:39:52 2012 +0000

    RFCreateReaderHandle(): fix compiler warning
    
    readerfactory.c: In function ‘RFCreateReaderHandle’:
    readerfactory.c:1054: warning: unused parameter ‘rContext’
    
    Maybe the rContext will be used one day.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6447 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 2 ++
 1 file changed, 2 insertions(+)

commit 23c972296eead14d4f9d07a4d447b2d8fa3e56ad
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 24 09:07:18 2012 +0000

    Fix redirection of stdin, stdout and stderr to /dev/null
    
    The file descriptors for stdin, stdout and stderr were closed so any
    library (like libusb) sending debug log to stderr was confusing pcscd
    since file descriptor 2 (ex stderr) was re-used for something else.
    
    Now the file descriptor 3 is really redirected to /dev/null
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6446 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/pcscdaemon.c | 15 ++++++++++++---
 1 file changed, 12 insertions(+), 3 deletions(-)

commit ddf0200af5d7b3c06d740ac28ad391149d5d7731
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 24 08:27:10 2012 +0000

    Increase DEBUG_BUF_SIZE to avoid log lines truncations
    
    Increase the value from 160 to 2048. Some "long" log lines where
    truncated.
    
    Example:
    Aug 24 10:22:39 neo pcscd: readerfactory.c:978:RFInitializeReader() Attempting startup of Gemalto PC Twin Reader (70D7E2EE) 00 00 using /usr/lib/pcsc/drivers/ifd-ccid.bundle/Contents/Lin
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6445 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/debuglog.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a2226fbc24663a15e7e2514406552c310da99180
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 24 08:10:23 2012 +0000

    Remove useless parenthesis
    
    Replace the constructions &(structure->field) by &structure->field since
    that is equivalent.
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6444 0ce88b0d-b2fd-0310-8134-9614164e65ea

 src/readerfactory.c | 24 ++++++++++++------------
 src/winscard_clnt.c | 20 ++++++++++----------
 src/winscard_svc.c  | 32 ++++++++++++++++----------------
 3 files changed, 38 insertions(+), 38 deletions(-)

commit 4e090dac0b61dd5e8777208aff133fd4c0aa6317
Author: Ludovic Rousseau <ludovic.rousseau@free.fr>
Date:   Fri Aug 24 07:59:57 2012 +0000

    MSGAddHandle(): Add mutex lock/unlock around cardsList list
    
    A lock/unlock pair of mutex was missing.
    
    Thanks to Dmitry Torokhov <dtor@vmware.com> for the patch
    
    
    git-svn-id: svn://anonscm.debian.org/svn/pcsclite/trunk/PCSC@6443 0ce88b0d-b2fd-0310-8134-9614164e65ea

